var b$2 = (t, e, n) => {
  if (!e.has(t))
    throw TypeError("Cannot " + n);
};
var r = (t, e, n) => (b$2(t, e, "read from private field"), n ? n.call(t) : e.get(t)), m$2 = (t, e, n) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, n);
}, a$1 = (t, e, n, s) => (b$2(t, e, "write to private field"), s ? s.call(t, n) : e.set(t, n), n);
var l$1;
let I$3 = class I {
  constructor(e, n) {
    m$2(this, l$1, void 0);
    this.value = e, a$1(this, l$1, n), this.mql = null;
  }
  get handler() {
    return r(this, l$1);
  }
  // Unmount existing handler before setting a new one.
  set handler(e) {
    this.mql && this.mql.removeEventListener("change", r(this, l$1)), a$1(this, l$1, e);
  }
  mount(e, n) {
    return e && (this.value = e), n && a$1(this, l$1, n), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), this.mql.addEventListener("change", r(this, l$1)), r(this, l$1).call(this, this.mql), this) : this;
  }
  unmount() {
    return this.mql ? (this.mql.removeEventListener("change", r(this, l$1)), this.value = null, a$1(this, l$1, null), this.mql = null, this) : this;
  }
};
l$1 = /* @__PURE__ */ new WeakMap();
let L$2 = class L {
  constructor() {
    this.collection = [];
  }
  async register(e) {
    return await this.deregister(e), this.collection.push(e), this.collection;
  }
  async deregister(e) {
    const n = this.collection.findIndex((s) => s === e);
    if (n >= 0) {
      const s = this.collection[n];
      Object.getOwnPropertyNames(s).forEach((o2) => {
        delete s[o2];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(e) {
    return await Promise.all(Array.from(e, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(e, n = "id") {
    return this.collection.find((s) => s[n] === e);
  }
};
const i = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, g$2 = [
  `a[href]${i.inert}${i.negTabIndex}`,
  `area[href]${i.inert}${i.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${i.inert}${i.negTabIndex}${i.disabled}`,
  `input[type="radio"]${i.inert}${i.negTabIndex}${i.disabled}`,
  `select${i.inert}${i.negTabIndex}${i.disabled}`,
  `textarea${i.inert}${i.negTabIndex}${i.disabled}`,
  `button${i.inert}${i.negTabIndex}${i.disabled}`,
  `details${i.inert} > summary:first-of-type${i.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${i.inert}${i.negTabIndex}`,
  `audio[controls]${i.inert}${i.negTabIndex}`,
  `video[controls]${i.inert}${i.negTabIndex}`,
  `[contenteditable]${i.inert}${i.negTabIndex}`,
  `[tabindex]${i.inert}${i.negTabIndex}`
];
var f$2, u$2, d$2;
let S$3 = class S {
  constructor(e = null, n = "[data-focus]") {
    m$2(this, f$2, void 0);
    m$2(this, u$2, void 0);
    m$2(this, d$2, void 0);
    this.el = e, this.selectorFocus = n, a$1(this, u$2, $$2.bind(this)), a$1(this, d$2, y$2.bind(this));
  }
  get focusable() {
    return r(this, f$2);
  }
  set focusable(e) {
    a$1(this, f$2, e), r(this, f$2).length ? (document.removeEventListener("keydown", r(this, d$2)), document.addEventListener("keydown", r(this, u$2))) : (document.removeEventListener("keydown", r(this, u$2)), document.addEventListener("keydown", r(this, d$2)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(e, n) {
    e && (this.el = e), n && (this.selectorFocus = n), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", r(this, u$2)), document.removeEventListener("keydown", r(this, d$2));
  }
  focus(e = this.el, n = this.selectorFocus) {
    (e.querySelector(n) || e).focus();
  }
  getFocusable(e = this.el) {
    const n = [], s = document.activeElement, o2 = e.scrollTop;
    return e.querySelectorAll(g$2.join(",")).forEach((h2) => {
      h2.focus(), document.activeElement === h2 && n.push(h2);
    }), e.scrollTop = o2, s.focus(), n;
  }
};
f$2 = /* @__PURE__ */ new WeakMap(), u$2 = /* @__PURE__ */ new WeakMap(), d$2 = /* @__PURE__ */ new WeakMap();
function $$2(t) {
  (t.key === "Tab" || t.keyCode === 9) && (t.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (t.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (t.preventDefault(), this.focusableFirst.focus()));
}
function y$2(t) {
  (t.key === "Tab" || t.keyCode === 9) && t.preventDefault();
}
function v$2() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-prefix").trim();
}
function T$2(t, e = document.body, n = true) {
  if (n) {
    const o2 = v$2();
    o2 && !t.includes(`--${o2}`) && (t = t.replace("--", `--${o2}`));
  }
  const s = getComputedStyle(e).getPropertyValue(t).trim();
  if (s)
    return s;
  throw new Error(`CSS variable "${t}" was not found!`);
}
function q$2(t, e) {
  const s = (t.getAttribute(`data-${e}`) || "").replace(/'/g, '"');
  return s ? JSON.parse(s) : {};
}
function F$3(t, e = true) {
  const n = localStorage.getItem(t), s = n ? JSON.parse(n) : {};
  return {
    get(o2) {
      return o2 ? s[o2] : s;
    },
    set(o2, c2) {
      return c2 ? s[o2] = c2 : delete s[o2], e && localStorage.setItem(t, JSON.stringify(s)), s;
    }
  };
}
function k$3(t, e, n) {
  const s = e.nodeType === Node.COMMENT_NODE, o2 = e.nodeType === Node.ELEMENT_NODE;
  if (e = s || o2 ? e : document.querySelector(e), s && (n = "after"), !e)
    throw new Error(`Not a valid teleport reference: '${e}'`);
  if (typeof e[n] != "function")
    throw new Error(`Not a valid teleport method: '${n}'`);
  let c2 = null;
  return s || (c2 = document.createComment("teleported #" + t.id), t.before(c2)), e[n](t), s && e.remove(), c2;
}
function w$2(t, e, n, s = "--transition-duration") {
  return new Promise((o2) => {
    if (typeof s == "string") {
      const c2 = T$2(s, t), h2 = !!c2.includes("ms");
      s = parseFloat(c2) * (h2 ? 1 : 1e3);
    }
    t.classList.remove(e.finish), t.classList.add(n.start), setTimeout(() => {
      t.classList.add(n.finish), t.classList.remove(n.start), o2(t);
    }, s);
  });
}
function p$2(t, e) {
  e && document.querySelectorAll(e).forEach((s) => {
    t ? s.style.overflow = "hidden" : s.style.removeProperty("overflow");
  });
}
function E$2(t, e) {
  e && document.querySelectorAll(e).forEach((s) => {
    t ? (s.inert = true, s.setAttribute("aria-hidden", true)) : (s.inert = null, s.removeAttribute("aria-hidden"));
  });
}
function C$2(t, e) {
  E$2(!!t, e.selectorInert), p$2(!!t, e.selectorOverflow);
}
const index = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  Breakpoint: I$3,
  Collection: L$2,
  FocusTrap: S$3,
  cssVar: T$2,
  getConfig: q$2,
  getPrefix: v$2,
  localStore: F$3,
  teleport: k$3,
  transition: w$2,
  updateGlobalState: C$2
}, Symbol.toStringTag, { value: "Module" }));
var I$2 = (t, s, e) => {
  if (!s.has(t))
    throw TypeError("Cannot " + e);
};
var b$1 = (t, s, e) => (I$2(t, s, "read from private field"), e ? e.call(t) : s.get(t)), $$1 = (t, s, e) => {
  if (s.has(t))
    throw TypeError("Cannot add the same private member more than once");
  s instanceof WeakSet ? s.add(t) : s.set(t, e);
}, S$2 = (t, s, e, i2) => (I$2(t, s, "write to private field"), i2 ? i2.call(t, e) : s.set(t, e), e);
var O$1 = (t, s, e) => {
  if (!s.has(t))
    throw TypeError("Cannot " + e);
}, l = (t, s, e) => (O$1(t, s, "read from private field"), e ? e.call(t) : s.get(t)), w$1 = (t, s, e) => {
  if (s.has(t))
    throw TypeError("Cannot add the same private member more than once");
  s instanceof WeakSet ? s.add(t) : s.set(t, e);
}, u$1 = (t, s, e, i2) => (O$1(t, s, "write to private field"), i2 ? i2.call(t, e) : s.set(t, e), e), d$1;
let P$1 = class P {
  constructor(s, e) {
    w$1(this, d$1, void 0), this.value = s, u$1(this, d$1, e), this.mql = null;
  }
  get handler() {
    return l(this, d$1);
  }
  // Unmount existing handler before setting a new one.
  set handler(s) {
    this.mql && this.mql.removeEventListener("change", l(this, d$1)), u$1(this, d$1, s);
  }
  mount(s, e) {
    return s && (this.value = s), e && u$1(this, d$1, e), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), this.mql.addEventListener("change", l(this, d$1)), l(this, d$1).call(this, this.mql), this) : this;
  }
  unmount() {
    return this.mql ? (this.mql.removeEventListener("change", l(this, d$1)), this.value = null, u$1(this, d$1, null), this.mql = null, this) : this;
  }
};
d$1 = /* @__PURE__ */ new WeakMap();
let A$1 = class A {
  constructor() {
    this.collection = [];
  }
  async register(s) {
    return await this.deregister(s), this.collection.push(s), this.collection;
  }
  async deregister(s) {
    const e = this.collection.findIndex((i2) => i2 === s);
    if (e >= 0) {
      const i2 = this.collection[e];
      Object.getOwnPropertyNames(i2).forEach((n) => {
        delete i2[n];
      }), this.collection.splice(e, 1);
    }
    return this.collection;
  }
  async registerCollection(s) {
    return await Promise.all(Array.from(s, (e) => {
      this.register(e);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(s, e = "id") {
    return this.collection.find((i2) => i2[e] === s);
  }
};
const o$1 = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, B$1 = [
  `a[href]${o$1.inert}${o$1.negTabIndex}`,
  `area[href]${o$1.inert}${o$1.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${o$1.inert}${o$1.negTabIndex}${o$1.disabled}`,
  `input[type="radio"]${o$1.inert}${o$1.negTabIndex}${o$1.disabled}`,
  `select${o$1.inert}${o$1.negTabIndex}${o$1.disabled}`,
  `textarea${o$1.inert}${o$1.negTabIndex}${o$1.disabled}`,
  `button${o$1.inert}${o$1.negTabIndex}${o$1.disabled}`,
  `details${o$1.inert} > summary:first-of-type${o$1.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${o$1.inert}${o$1.negTabIndex}`,
  `audio[controls]${o$1.inert}${o$1.negTabIndex}`,
  `video[controls]${o$1.inert}${o$1.negTabIndex}`,
  `[contenteditable]${o$1.inert}${o$1.negTabIndex}`,
  `[tabindex]${o$1.inert}${o$1.negTabIndex}`
];
var v$1, g$1, f$1;
let j$2 = class j {
  constructor(s = null, e = "[data-focus]") {
    w$1(this, v$1, void 0), w$1(this, g$1, void 0), w$1(this, f$1, void 0), this.el = s, this.selectorFocus = e, u$1(this, g$1, q$1.bind(this)), u$1(this, f$1, K$2.bind(this));
  }
  get focusable() {
    return l(this, v$1);
  }
  set focusable(s) {
    u$1(this, v$1, s), l(this, v$1).length ? (document.removeEventListener("keydown", l(this, f$1)), document.addEventListener("keydown", l(this, g$1))) : (document.removeEventListener("keydown", l(this, g$1)), document.addEventListener("keydown", l(this, f$1)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(s, e) {
    s && (this.el = s), e && (this.selectorFocus = e), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", l(this, g$1)), document.removeEventListener("keydown", l(this, f$1));
  }
  focus(s = this.el, e = this.selectorFocus) {
    (s.querySelector(e) || s).focus();
  }
  getFocusable(s = this.el) {
    const e = [], i2 = document.activeElement, n = s.scrollTop;
    return s.querySelectorAll(B$1.join(",")).forEach((c2) => {
      c2.focus(), document.activeElement === c2 && e.push(c2);
    }), s.scrollTop = n, i2.focus(), e;
  }
};
v$1 = /* @__PURE__ */ new WeakMap(), g$1 = /* @__PURE__ */ new WeakMap(), f$1 = /* @__PURE__ */ new WeakMap();
function q$1(t) {
  (t.key === "Tab" || t.keyCode === 9) && (t.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (t.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (t.preventDefault(), this.focusableFirst.focus()));
}
function K$2(t) {
  (t.key === "Tab" || t.keyCode === 9) && t.preventDefault();
}
function y$1() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-prefix").trim();
}
function N$2(t, s = document.body, e = true) {
  if (e) {
    const n = y$1();
    n && !t.includes(`--${n}`) && (t = t.replace("--", `--${n}`));
  }
  const i2 = getComputedStyle(s).getPropertyValue(t).trim();
  if (i2)
    return i2;
  throw new Error(`CSS variable "${t}" was not found!`);
}
function V$1(t, s) {
  const e = (t.getAttribute(`data-${s}`) || "").replace(/'/g, '"');
  return e ? JSON.parse(e) : {};
}
function W$1(t, s = true) {
  const e = localStorage.getItem(t), i2 = e ? JSON.parse(e) : {};
  return {
    get(n) {
      return n ? i2[n] : i2;
    },
    set(n, c2) {
      return c2 ? i2[n] = c2 : delete i2[n], s && localStorage.setItem(t, JSON.stringify(i2)), i2;
    }
  };
}
function M$1(t, s, e, i2 = "--transition-duration") {
  return new Promise((n) => {
    if (typeof i2 == "string") {
      const c2 = N$2(i2, t), r2 = !!c2.includes("ms");
      i2 = parseFloat(c2) * (r2 ? 1 : 1e3);
    }
    t.classList.remove(s.finish), t.classList.add(e.start), setTimeout(() => {
      t.classList.add(e.finish), t.classList.remove(e.start), n(t);
    }, i2);
  });
}
function _$2(t, s) {
  s && document.querySelectorAll(s).forEach((e) => {
    t ? e.style.overflow = "hidden" : e.style.removeProperty("overflow");
  });
}
function J$2(t, s) {
  s && document.querySelectorAll(s).forEach((e) => {
    t ? (e.inert = true, e.setAttribute("aria-hidden", true)) : (e.inert = null, e.removeAttribute("aria-hidden"));
  });
}
function k$2(t, s) {
  J$2(!!t, s.selectorInert), _$2(!!t, s.selectorOverflow);
}
const z$1 = {
  autoInit: false,
  // Data attributes
  dataOpen: "drawer-open",
  dataClose: "drawer-close",
  dataToggle: "drawer-toggle",
  dataBreakpoint: "drawer-breakpoint",
  dataConfig: "drawer-config",
  // Selectors
  selectorDrawer: ".drawer",
  selectorDialog: ".drawer__dialog",
  selectorScreen: ".drawer",
  selectorFocus: "[data-focus]",
  selectorInert: null,
  selectorOverflow: "body",
  // State classes
  stateOpened: "is-opened",
  stateOpening: "is-opening",
  stateClosing: "is-closing",
  stateClosed: "is-closed",
  // Classes
  classModal: "drawer_modal",
  // Feature toggles
  breakpoints: null,
  customEventPrefix: "drawer:",
  eventListeners: true,
  store: true,
  storeKey: "VB:DrawerState",
  setTabindex: true,
  transition: true,
  transitionDuration: "--vb-drawer-transition-duration"
};
async function G$1(t) {
  const s = t.target.closest(`
    [data-${this.settings.dataOpen}],
    [data-${this.settings.dataToggle}],
    [data-${this.settings.dataClose}]
  `);
  if (s) {
    t.preventDefault(), s.matches(`[data-${this.settings.dataToggle}]`) && s.getAttribute(`data-${this.settings.dataToggle}`).trim().split(" ").forEach((i2) => {
      const n = this.get(i2);
      return n.trigger = s, n.toggle();
    }), s.matches(`[data-${this.settings.dataOpen}]`) && s.getAttribute(`data-${this.settings.dataOpen}`).trim().split(" ").forEach((i2) => {
      const n = this.get(i2);
      return n.trigger = s, n.open();
    }), s.matches(`[data-${this.settings.dataClose}]`) && s.getAttribute(`data-${this.settings.dataClose}`).trim().split(" ").forEach((i2) => {
      if (i2) {
        const n = this.get(i2);
        return n.trigger = s, n.close();
      } else {
        const n = t.target.closest(this.settings.selectorDrawer);
        if (n)
          return this.close(n);
      }
    });
    return;
  }
  if (this.activeModal && t.target.matches(this.settings.selectorScreen))
    return this.close(this.activeModal.id);
}
function H$1(t) {
  if (t.key === "Escape" && this.activeModal)
    return this.close(this.activeModal);
}
async function L$1(t, s = true) {
  const e = this.collection.findIndex((i2) => i2.id === t.id);
  if (e >= 0) {
    const i2 = this.collection[e];
    s && i2.state === "opened" && await i2.close(false), this.store.set(i2.id), i2.unmountBreakpoint(), Object.getOwnPropertyNames(i2).forEach((n) => {
      delete i2[n];
    }), this.collection.splice(e, 1);
  }
  return this.collection;
}
function Q$1(t) {
  t.store === "opened" ? t.open(false, false) : t.store === "closed" ? t.close(false, false) : t.store === "indeterminate" ? t.state = "indeterminate" : t.el.classList.contains(t.getSetting("stateOpened")) ? t.open(false, false) : t.el.classList.contains(t.getSetting("stateClosed")) ? t.close(false, false) : t.state = "indeterminate";
}
async function R$1(t) {
  t.store === "opened" ? await t.open(false, false) : t.store === "closed" ? await t.close(false, false) : t.store === "indeterminate" ? t.state != "indeterminate" && (t.state = "indeterminate") : (t.state != t.inlineState && (t.state = t.inlineState), t.inlineState === "opened" ? await t.open(false, false) : t.inlineState === "closed" && await t.close(false, false));
}
function U(t) {
  const s = y$1(), e = t.getAttribute(`data-${this.settings.dataBreakpoint}`);
  return this.settings.breakpoints && this.settings.breakpoints[e] ? this.settings.breakpoints[e] : getComputedStyle(document.body).getPropertyValue(`--${s}breakpoint-${e}`).trim() ? getComputedStyle(document.body).getPropertyValue(`--${s}breakpoint-${e}`).trim() : e;
}
function C$1(t) {
  const s = typeof t == "string" ? this.get(t) : this.get(t.id);
  if (s)
    return s;
  throw new Error(`Drawer not found in collection with id of "${t.id || t}".`);
}
function D$2(t) {
  t.state === "opened" ? t.mode === "modal" ? this.focusTrap.mount(t.dialog, this.settings.selectorFocus) : this.focusTrap.focus(t.dialog, this.settings.selectorFocus) : (t.trigger && (t.trigger.focus(), t.trigger = null), this.focusTrap.unmount());
}
async function x$1(t, s, e = true) {
  const i2 = C$1.call(this, t), n = { ...this.settings, ...i2.settings };
  return s !== void 0 && (n.transition = s), (i2.state === "closed" || i2.state === "indeterminate") && (i2.state = "opening", n.transition ? await M$1(i2.el, {
    start: n.stateClosing,
    finish: n.stateClosed
  }, {
    start: n.stateOpening,
    finish: n.stateOpened
  }, n.transitionDuration) : (i2.el.classList.add(n.stateOpened), i2.el.classList.remove(n.stateClosed)), i2.state = "opened", i2.mode === "modal" && k$2(true, n), e && D$2.call(this, i2), i2.el.dispatchEvent(new CustomEvent(n.customEventPrefix + "opened", {
    detail: this,
    bubbles: true
  }))), i2;
}
async function E$1(t, s, e = true) {
  const i2 = C$1.call(this, t), n = { ...this.settings, ...i2.settings };
  return s !== void 0 && (n.transition = s), (i2.state === "opened" || i2.state === "indeterminate") && (i2.state = "closing", document.activeElement.blur(), n.transition ? await M$1(i2.el, {
    start: n.stateOpening,
    finish: n.stateOpened
  }, {
    start: n.stateClosing,
    finish: n.stateClosed
  }, n.transitionDuration) : (i2.el.classList.add(n.stateClosed), i2.el.classList.remove(n.stateOpened)), i2.state = "closed", i2.mode === "modal" && k$2(false, n), e && D$2.call(this, i2), i2.el.dispatchEvent(new CustomEvent(n.customEventPrefix + "closed", {
    detail: this,
    bubbles: true
  }))), i2;
}
async function F$2(t, s, e) {
  const i2 = C$1.call(this, t);
  return i2.state === "closed" ? x$1.call(this, i2, s, e) : E$1.call(this, i2, s, e);
}
function X(t) {
  switch (t.mode) {
    case "inline":
      return Y.call(this, t);
    case "modal":
      return Z$1.call(this, t);
    default:
      throw new Error(`"${t.mode}" is not a valid drawer mode.`);
  }
}
async function Y(t) {
  return t.el.classList.remove(t.getSetting("classModal")), t.dialog.removeAttribute("aria-modal"), k$2(false, { ...this.settings, ...t.settings }), this.focusTrap.unmount(), await R$1(t), t.el.dispatchEvent(new CustomEvent(t.getSetting("customEventPrefix") + "switchMode", {
    detail: this,
    bubbles: true
  })), t;
}
async function Z$1(t) {
  return t.el.classList.add(t.getSetting("classModal")), t.dialog.setAttribute("aria-modal", "true"), await E$1.call(this, t, false, false), t.el.dispatchEvent(new CustomEvent(t.getSetting("customEventPrefix") + "switchMode", {
    detail: this,
    bubbles: true
  })), t;
}
async function tt$1(t, s = {}) {
  await L$1.call(this, t, false);
  const e = this, i2 = new P$1();
  let n, c2 = "indeterminate";
  const r2 = {
    id: t.id,
    el: t,
    dialog: null,
    trigger: null,
    settings: { ...V$1(t, this.settings.dataConfig), ...s },
    inlineState: "indeterminate",
    get breakpoint() {
      return U.call(e, t);
    },
    get store() {
      return e.store.get(this.id);
    },
    get mode() {
      return n;
    },
    set mode(a2) {
      n = a2, X.call(e, this);
    },
    get state() {
      return c2;
    },
    set state(a2) {
      c2 = a2, this.mode === "inline" && a2 != "opening" && a2 != "closing" && (this.inlineState = a2, this.getSetting("store") && e.store.set(this.id, a2)), a2 === "indeterminate" && (this.el.classList.remove(this.getSetting("stateOpened")), this.el.classList.remove(this.getSetting("stateOpening")), this.el.classList.remove(this.getSetting("stateClosed")), this.el.classList.remove(this.getSetting("stateClosing")));
    },
    open(a2, h2) {
      return x$1.call(e, this, a2, h2);
    },
    close(a2, h2) {
      return E$1.call(e, this, a2, h2);
    },
    toggle(a2, h2) {
      return F$2.call(e, this, a2, h2);
    },
    deregister() {
      return L$1.call(e, this);
    },
    mountBreakpoint() {
      const a2 = this.breakpoint, h2 = this.handleBreakpoint.bind(this);
      return i2.mount(a2, h2), this;
    },
    unmountBreakpoint() {
      return i2.unmount(), this;
    },
    handleBreakpoint(a2) {
      const h2 = a2.matches ? "inline" : "modal";
      return this.mode != h2 && (this.mode = h2), this;
    },
    getSetting(a2) {
      return a2 in this.settings ? this.settings[a2] : e.settings[a2];
    }
  };
  this.collection.push(r2);
  const T2 = t.querySelector(r2.getSetting("selectorDialog"));
  return r2.dialog = T2 || t, r2.getSetting("setTabindex") && r2.dialog.setAttribute("tabindex", "-1"), await Q$1(r2), r2.inlineState = r2.state, r2.mode = t.classList.contains(r2.getSetting("classModal")) ? "modal" : "inline", r2.breakpoint && r2.mountBreakpoint(), r2;
}
var m$1, p$1;
let st$1 = class st extends A$1 {
  constructor(e) {
    super();
    $$1(this, m$1, void 0);
    $$1(this, p$1, void 0);
    this.defaults = z$1, this.settings = { ...this.defaults, ...e }, this.focusTrap = new j$2(), this.store = W$1(this.settings.storeKey, this.settings.store), S$2(this, m$1, G$1.bind(this)), S$2(this, p$1, H$1.bind(this)), this.settings.autoInit && this.init();
  }
  get activeModal() {
    return this.collection.find((e) => e.state === "opened" && e.mode === "modal");
  }
  async init(e = null) {
    e && (this.settings = { ...this.settings, ...e });
    const i2 = document.querySelectorAll(this.settings.selectorDrawer);
    return await this.registerCollection(i2), this.settings.eventListeners && this.initEventListeners(), this;
  }
  async destroy() {
    return await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
  }
  initEventListeners() {
    document.addEventListener("click", b$1(this, m$1), false), document.addEventListener("keydown", b$1(this, p$1), false);
  }
  destroyEventListeners() {
    document.removeEventListener("click", b$1(this, m$1), false), document.removeEventListener("keydown", b$1(this, p$1), false);
  }
  register(e, i2 = {}) {
    let n = typeof e == "string" ? document.getElementById(e) : e;
    return n ? tt$1.call(this, n, i2) : Promise.reject(new Error(`Failed to register; drawer not found with ID of: "${e.id || e}".`));
  }
  deregister(e) {
    let i2 = this.get(e.id || e);
    return i2 ? L$1.call(this, i2) : Promise.reject(new Error(`Failed to deregister; drawer does not exist in collection with ID of: "${e.id || e}".`));
  }
  open(e, i2, n) {
    return x$1.call(this, e, i2, n);
  }
  close(e, i2, n) {
    return E$1.call(this, e, i2, n);
  }
  toggle(e, i2, n) {
    return F$2.call(this, e, i2, n);
  }
};
m$1 = /* @__PURE__ */ new WeakMap(), p$1 = /* @__PURE__ */ new WeakMap();
var I$1 = (i2, s, t) => {
  if (!s.has(i2))
    throw TypeError("Cannot " + t);
};
var f = (i2, s, t) => (I$1(i2, s, "read from private field"), t ? t.call(i2) : s.get(i2)), m = (i2, s, t) => {
  if (s.has(i2))
    throw TypeError("Cannot add the same private member more than once");
  s instanceof WeakSet ? s.add(i2) : s.set(i2, t);
}, v = (i2, s, t, e) => (I$1(i2, s, "write to private field"), e ? e.call(i2, t) : s.set(i2, t), t);
var T$1 = (i2, s, t) => {
  if (!s.has(i2))
    throw TypeError("Cannot " + t);
}, a = (i2, s, t) => (T$1(i2, s, "read from private field"), t ? t.call(i2) : s.get(i2)), b = (i2, s, t) => {
  if (s.has(i2))
    throw TypeError("Cannot add the same private member more than once");
  s instanceof WeakSet ? s.add(i2) : s.set(i2, t);
}, y = (i2, s, t, e) => (T$1(i2, s, "write to private field"), e ? e.call(i2, t) : s.set(i2, t), t);
class O {
  constructor() {
    this.collection = [];
  }
  async register(s) {
    return await this.deregister(s), this.collection.push(s), this.collection;
  }
  async deregister(s) {
    const t = this.collection.findIndex((e) => e === s);
    if (t >= 0) {
      const e = this.collection[t];
      Object.getOwnPropertyNames(e).forEach((n) => {
        delete e[n];
      }), this.collection.splice(t, 1);
    }
    return this.collection;
  }
  async registerCollection(s) {
    return await Promise.all(Array.from(s, (t) => {
      this.register(t);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(s, t = "id") {
    return this.collection.find((e) => e[t] === s);
  }
}
const o = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, A2 = [
  `a[href]${o.inert}${o.negTabIndex}`,
  `area[href]${o.inert}${o.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${o.inert}${o.negTabIndex}${o.disabled}`,
  `input[type="radio"]${o.inert}${o.negTabIndex}${o.disabled}`,
  `select${o.inert}${o.negTabIndex}${o.disabled}`,
  `textarea${o.inert}${o.negTabIndex}${o.disabled}`,
  `button${o.inert}${o.negTabIndex}${o.disabled}`,
  `details${o.inert} > summary:first-of-type${o.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${o.inert}${o.negTabIndex}`,
  `audio[controls]${o.inert}${o.negTabIndex}`,
  `video[controls]${o.inert}${o.negTabIndex}`,
  `[contenteditable]${o.inert}${o.negTabIndex}`,
  `[tabindex]${o.inert}${o.negTabIndex}`
];
var g, c, d;
class M {
  constructor(s = null, t = "[data-focus]") {
    b(this, g, void 0), b(this, c, void 0), b(this, d, void 0), this.el = s, this.selectorFocus = t, y(this, c, P2.bind(this)), y(this, d, R.bind(this));
  }
  get focusable() {
    return a(this, g);
  }
  set focusable(s) {
    y(this, g, s), a(this, g).length ? (document.removeEventListener("keydown", a(this, d)), document.addEventListener("keydown", a(this, c))) : (document.removeEventListener("keydown", a(this, c)), document.addEventListener("keydown", a(this, d)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(s, t) {
    s && (this.el = s), t && (this.selectorFocus = t), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", a(this, c)), document.removeEventListener("keydown", a(this, d));
  }
  focus(s = this.el, t = this.selectorFocus) {
    (s.querySelector(t) || s).focus();
  }
  getFocusable(s = this.el) {
    const t = [], e = document.activeElement, n = s.scrollTop;
    return s.querySelectorAll(A2.join(",")).forEach((r2) => {
      r2.focus(), document.activeElement === r2 && t.push(r2);
    }), s.scrollTop = n, e.focus(), t;
  }
}
g = /* @__PURE__ */ new WeakMap(), c = /* @__PURE__ */ new WeakMap(), d = /* @__PURE__ */ new WeakMap();
function P2(i2) {
  (i2.key === "Tab" || i2.keyCode === 9) && (i2.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (i2.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (i2.preventDefault(), this.focusableFirst.focus()));
}
function R(i2) {
  (i2.key === "Tab" || i2.keyCode === 9) && i2.preventDefault();
}
function F$1() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-prefix").trim();
}
function D$1(i2, s = document.body, t = true) {
  if (t) {
    const n = F$1();
    n && !i2.includes(`--${n}`) && (i2 = i2.replace("--", `--${n}`));
  }
  const e = getComputedStyle(s).getPropertyValue(i2).trim();
  if (e)
    return e;
  throw new Error(`CSS variable "${i2}" was not found!`);
}
function N$1(i2, s) {
  const t = (i2.getAttribute(`data-${s}`) || "").replace(/'/g, '"');
  return t ? JSON.parse(t) : {};
}
function L2(i2, s, t) {
  const e = s.nodeType === Node.COMMENT_NODE, n = s.nodeType === Node.ELEMENT_NODE;
  if (s = e || n ? s : document.querySelector(s), e && (t = "after"), !s)
    throw new Error(`Not a valid teleport reference: '${s}'`);
  if (typeof s[t] != "function")
    throw new Error(`Not a valid teleport method: '${t}'`);
  let r2 = null;
  return e || (r2 = document.createComment("teleported #" + i2.id), i2.before(r2)), s[t](i2), e && s.remove(), r2;
}
function S$1(i2, s, t, e = "--transition-duration") {
  return new Promise((n) => {
    if (typeof e == "string") {
      const r2 = D$1(e, i2), l2 = !!r2.includes("ms");
      e = parseFloat(r2) * (l2 ? 1 : 1e3);
    }
    i2.classList.remove(s.finish), i2.classList.add(t.start), setTimeout(() => {
      i2.classList.add(t.finish), i2.classList.remove(t.start), n(i2);
    }, e);
  });
}
function z(i2, s) {
  s && document.querySelectorAll(s).forEach((t) => {
    i2 ? t.style.overflow = "hidden" : t.style.removeProperty("overflow");
  });
}
function j$1(i2, s) {
  s && document.querySelectorAll(s).forEach((t) => {
    i2 ? (t.inert = true, t.setAttribute("aria-hidden", true)) : (t.inert = null, t.removeAttribute("aria-hidden"));
  });
}
function W(i2, s) {
  j$1(!!i2, s.selectorInert), z(!!i2, s.selectorOverflow);
}
const _$1 = {
  autoInit: false,
  // Data attributes
  dataOpen: "modal-open",
  dataClose: "modal-close",
  dataReplace: "modal-replace",
  dataConfig: "modal-config",
  // Selectors
  selectorModal: ".modal",
  selectorDialog: ".modal__dialog",
  selectorScreen: ".modal",
  selectorRequired: '[role="alertdialog"]',
  selectorFocus: "[data-focus]",
  selectorInert: null,
  selectorOverflow: "body",
  // State classes
  stateOpened: "is-opened",
  stateOpening: "is-opening",
  stateClosing: "is-closing",
  stateClosed: "is-closed",
  // Feature settings
  customEventPrefix: "modal:",
  eventListeners: true,
  teleport: null,
  teleportMethod: "append",
  setTabindex: true,
  transition: true,
  transitionDuration: "--vb-modal-transition-duration"
};
async function G(i2) {
  const s = i2.target.closest(`
    [data-${this.settings.dataOpen}],
    [data-${this.settings.dataReplace}],
    [data-${this.settings.dataClose}]
  `);
  if (s) {
    if (i2.preventDefault(), s.matches(`[data-${this.settings.dataOpen}]`)) {
      const t = s.getAttribute(`data-${this.settings.dataOpen}`).trim(), e = this.get(t);
      return i2.target.closest(this.settings.selectorModal) || (this.trigger = s), e.open();
    }
    if (s.matches(`[data-${this.settings.dataReplace}]`)) {
      const t = s.getAttribute(`data-${this.settings.dataReplace}`).trim(), e = this.get(t);
      return i2.target.closest(this.settings.selectorModal) || (this.trigger = s), e.replace();
    }
    if (s.matches(`[data-${this.settings.dataClose}]`)) {
      const t = s.getAttribute(`data-${this.settings.dataClose}`).trim();
      return t === "*" ? this.closeAll() : this.close(t);
    }
  }
  if (this.active && i2.target.matches(this.settings.selectorScreen) && !this.active.required)
    return this.close(this.active.id);
}
function K$1(i2) {
  if (i2.key === "Escape" && this.active && !this.active.dialog.matches(this.settings.selectorRequired))
    return this.close();
}
async function w(i2, s = true) {
  const t = this.collection.findIndex((e) => e.id === i2.id);
  if (t >= 0) {
    const e = this.collection[t];
    s && e.state === "opened" ? await e.close(false) : this.stack.remove(e), e.getSetting("teleport") && e.teleportReturn(), Object.getOwnPropertyNames(e).forEach((n) => {
      delete e[n];
    }), this.collection.splice(t, 1);
  }
  return this.collection;
}
function $(i2) {
  const s = typeof i2 == "string" ? this.get(i2) : this.get(i2.id);
  if (s)
    return s;
  throw new Error(`Modal not found in collection with id of "${i2.id || i2}".`);
}
function p() {
  this.active ? this.focusTrap.mount(this.active.dialog, this.settings.selectorFocus) : (this.trigger && (this.trigger.focus(), this.trigger = null), this.focusTrap.unmount());
}
async function x(i2, s, t = true) {
  const e = $.call(this, i2), n = { ...this.settings, ...e.settings };
  return s !== void 0 && (n.transition = s), this.stack.moveToTop(e), e.state === "closed" && (e.state = "opening", this.stack.add(e), n.transition ? await S$1(e.el, {
    start: n.stateClosing,
    finish: n.stateClosed
  }, {
    start: n.stateOpening,
    finish: n.stateOpened
  }, n.transitionDuration) : (e.el.classList.add(n.stateOpened), e.el.classList.remove(n.stateClosed)), e.state = "opened"), t && p.call(this), e.el.dispatchEvent(new CustomEvent(n.customEventPrefix + "opened", {
    detail: this,
    bubbles: true
  })), e;
}
async function C(i2, s, t = true) {
  const e = i2 ? $.call(this, i2) : this.active;
  if (e && e.state === "opened") {
    e.state = "closing";
    const n = { ...this.settings, ...e.settings };
    s !== void 0 && (n.transition = s), document.activeElement.blur(), n.transition ? await S$1(e.el, {
      start: n.stateOpening,
      finish: n.stateOpened
    }, {
      start: n.stateClosing,
      finish: n.stateClosed
    }, n.transitionDuration) : (e.el.classList.add(n.stateClosed), e.el.classList.remove(n.stateOpened)), this.stack.remove(e), e.state = "closed", t && p.call(this), e.el.dispatchEvent(new CustomEvent(n.customEventPrefix + "closed", {
      detail: this,
      bubbles: true
    }));
  }
  return e;
}
async function E(i2, s) {
  const t = [];
  return await Promise.all(this.stack.value.map(async (e) => {
    i2 && i2 === e.id ? Promise.resolve() : t.push(await C.call(this, e, s, false)), e.trigger = null;
  })), t;
}
async function k$1(i2, s, t = true) {
  const e = $.call(this, i2);
  let n, r2;
  return e.state === "opened" ? (n = e, r2 = await E.call(this, e.id, s)) : (r2 = E.call(this, false, s), n = x.call(this, e, s, false), await Promise.all([n, r2])), t && p.call(this), { opened: n, closed: r2 };
}
async function V(i2, s = {}) {
  await w.call(this, i2, false);
  const t = this, e = {
    id: i2.id,
    state: "closed",
    el: i2,
    dialog: null,
    get required() {
      return this.dialog.matches(this.getSetting("selectorRequired"));
    },
    returnRef: null,
    settings: { ...N$1(i2, this.settings.dataConfig), ...s },
    open(r2, l2) {
      return x.call(t, this, r2, l2);
    },
    close(r2, l2) {
      return C.call(t, this, r2, l2);
    },
    replace(r2, l2) {
      return k$1.call(t, this, r2, l2);
    },
    deregister() {
      return w.call(t, this);
    },
    teleport(r2 = this.getSetting("teleport"), l2 = this.getSetting("teleportMethod")) {
      return this.returnRef ? (console.error("Element has already been teleported:", this.el), false) : (this.returnRef = L2(this.el, r2, l2), this.el);
    },
    teleportReturn() {
      return this.returnRef ? (this.returnRef = L2(this.el, this.returnRef), this.el) : (console.error("No return reference found:", this.el), false);
    },
    getSetting(r2) {
      return r2 in this.settings ? this.settings[r2] : t.settings[r2];
    }
  }, n = i2.querySelector(e.getSetting("selectorDialog"));
  return e.dialog = n || i2, e.dialog.setAttribute("aria-modal", "true"), e.dialog.hasAttribute("role") || e.dialog.setAttribute("role", "dialog"), e.getSetting("setTabindex") && e.dialog.setAttribute("tabindex", "-1"), e.getSetting("teleport") && e.teleport(), this.collection.push(e), e.el.classList.contains(this.settings.stateOpened) ? await e.open(false) : (e.el.classList.remove(this.settings.stateOpening), e.el.classList.remove(this.settings.stateClosing), e.el.classList.add(this.settings.stateClosed)), e;
}
function q(i2) {
  const s = [];
  return {
    get value() {
      return [...s];
    },
    get top() {
      return s[s.length - 1];
    },
    updateIndex() {
      s.forEach((t, e) => {
        t.el.style.zIndex = null;
        const n = getComputedStyle(t.el)["z-index"];
        t.el.style.zIndex = parseInt(n) + e + 1;
      });
    },
    updateGlobalState() {
      W(this.top, i2), this.updateIndex();
    },
    add(t) {
      t.el.style.zIndex = null;
      const e = getComputedStyle(t.el)["z-index"];
      t.el.style.zIndex = parseInt(e) + s.length + 1, s.push(t), this.updateGlobalState();
    },
    remove(t) {
      const e = s.findIndex((n) => n.id === t.id);
      e >= 0 && (t.el.style.zIndex = null, s.splice(e, 1), this.updateGlobalState());
    },
    moveToTop(t) {
      const e = s.findIndex((n) => n.id === t.id);
      e >= 0 && (s.splice(e, 1), this.add(t));
    }
  };
}
var u, h;
let J$1 = class J extends O {
  constructor(t) {
    super();
    m(this, u, void 0);
    m(this, h, void 0);
    this.defaults = _$1, this.settings = { ...this.defaults, ...t }, this.trigger = null, this.focusTrap = new M(), this.stack = q(this.settings), v(this, u, G.bind(this)), v(this, h, K$1.bind(this)), this.settings.autoInit && this.init();
  }
  get active() {
    return this.stack.top;
  }
  async init(t) {
    t && (this.settings = { ...this.settings, ...t });
    const e = document.querySelectorAll(this.settings.selectorModal);
    return await this.registerCollection(e), this.settings.eventListeners && this.initEventListeners(), this;
  }
  async destroy() {
    return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
  }
  initEventListeners() {
    document.addEventListener("click", f(this, u), false), document.addEventListener("keydown", f(this, h), false);
  }
  destroyEventListeners() {
    document.removeEventListener("click", f(this, u), false), document.removeEventListener("keydown", f(this, h), false);
  }
  register(t, e = {}) {
    let n = typeof t == "string" ? document.getElementById(t) : t;
    return n ? V.call(this, n, e) : Promise.reject(new Error(`Failed to register; modal not found with ID of: "${t.id || t}".`));
  }
  deregister(t) {
    let e = this.get(t.id || t);
    return e ? w.call(this, e) : Promise.reject(new Error(`Failed to deregister; modal does not exist in collection with ID of: "${t.id || t}".`));
  }
  open(t, e, n) {
    return x.call(this, t, e, n);
  }
  close(t, e, n) {
    return C.call(this, t, e, n);
  }
  replace(t, e, n) {
    return k$1.call(this, t, e, n);
  }
  async closeAll(t = false, e, n = true) {
    const r2 = await E.call(this, t, e);
    return n && p.call(this), r2;
  }
};
u = /* @__PURE__ */ new WeakMap(), h = /* @__PURE__ */ new WeakMap();
var Ue = (e, t, r2) => {
  if (!t.has(e))
    throw TypeError("Cannot " + r2);
};
var Ae = (e, t, r2) => (Ue(e, t, "read from private field"), r2 ? r2.call(e) : t.get(e)), _e = (e, t, r2) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, r2);
}, Ke = (e, t, r2, i2) => (Ue(e, t, "write to private field"), i2 ? i2.call(e, r2) : t.set(e, r2), r2);
class $t {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const r2 = this.collection.findIndex((i2) => i2 === t);
    if (r2 >= 0) {
      const i2 = this.collection[r2];
      Object.getOwnPropertyNames(i2).forEach((n) => {
        delete i2[n];
      }), this.collection.splice(r2, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (r2) => {
      this.register(r2);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, r2 = "id") {
    return this.collection.find((i2) => i2[r2] === t);
  }
}
function Ct() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-prefix").trim();
}
const kt = {
  autoInit: false,
  // Selectors
  selectorPopover: ".popover",
  selectorArrow: ".popover__arrow",
  // State classes
  stateActive: "is-active",
  // Feature settings
  eventListeners: true,
  eventType: "click",
  placement: "bottom"
};
function ot(e, t) {
  const r2 = getComputedStyle(e), i2 = {
    placement: t.placement,
    event: t.eventType,
    offset: 0,
    "overflow-padding": 0,
    "flip-padding": 0,
    "arrow-element": t.selectorArrow,
    "arrow-padding": 0
  };
  for (const n in i2) {
    const o2 = Ct(), l2 = r2.getPropertyValue(`--${o2}popover-${n}`).trim();
    l2 && (i2[n] = l2);
  }
  return i2;
}
function Pe(e) {
  let t;
  const r2 = typeof e == "string" ? e.trim().split(" ") : [e];
  switch (r2.forEach(function(i2, n) {
    r2[n] = parseInt(i2, 10);
  }), r2.length) {
    case 1:
      t = r2[0];
      break;
    case 2:
      t = {
        top: r2[0],
        right: r2[1],
        bottom: r2[0],
        left: r2[1]
      };
      break;
    case 3:
      t = {
        top: r2[0],
        right: r2[1],
        bottom: r2[2],
        left: r2[1]
      };
      break;
    case 4:
      t = {
        top: r2[0],
        right: r2[1],
        bottom: r2[2],
        left: r2[3]
      };
      break;
    default:
      t = false;
      break;
  }
  return t;
}
function Dt(e) {
  return [{
    name: "offset",
    options: {
      offset: [0, parseInt(e.offset, 10)]
    }
  }, {
    name: "preventOverflow",
    options: {
      padding: Pe(e["overflow-padding"])
    }
  }, {
    name: "flip",
    options: {
      padding: Pe(e["flip-padding"])
    }
  }, {
    name: "arrow",
    options: {
      element: e["arrow-element"],
      padding: Pe(e["arrow-padding"])
    }
  }];
}
function at(e) {
  const t = typeof e == "string" ? this.get(e) : this.get(e.id);
  if (t)
    return t;
  throw new Error(`Popover not found in collection with id of "${e}".`);
}
function Rt(e) {
  return typeof e == "string" ? e : typeof e.hasAttribute == "function" ? e.closest(this.settings.selectorPopover) ? (e = e.closest(this.settings.selectorPopover), e.id) : e.hasAttribute("aria-controls") ? e.getAttribute("aria-controls") : e.hasAttribute("aria-describedby") ? e.getAttribute("aria-describedby") : false : false;
}
function Bt(e) {
  const t = Rt.call(this, e);
  if (t) {
    const r2 = document.querySelector(`#${t}`), i2 = document.querySelector(`[aria-controls="${t}"]`) || document.querySelector(`[aria-describedby="${t}"]`);
    return !i2 && !r2 ? { error: new Error(`No popover elements found using the ID: "${t}".`) } : i2 ? r2 ? { popover: r2, trigger: i2 } : { error: new Error("No popover associated with the provided popover trigger.") } : { error: new Error("No popover trigger associated with the provided popover.") };
  } else
    return { error: new Error("Could not resolve the popover ID.") };
}
async function ke(e) {
  const t = e ? at.call(this, e) : await st2.call(this);
  return t && t.state === "opened" && (t.el.classList.remove(this.settings.stateActive), t.trigger.hasAttribute("aria-controls") && t.trigger.setAttribute("aria-expanded", "false"), t.popper.setOptions({
    modifiers: [{ name: "eventListeners", enabled: false }]
  }), t.state = "closed", t.trigger === this.trigger && (this.trigger = null)), t;
}
async function st2() {
  const e = [];
  return await Promise.all(this.collection.map(async (t) => {
    t.state === "opened" && e.push(await ke.call(this, t));
  })), e;
}
function ct(e) {
  e.state == "opened" && setTimeout(() => {
    const t = e.el.closest(":hover") === e.el || e.trigger.closest(":hover") === e.trigger, r2 = document.activeElement.closest(
      `#${e.id}, [aria-controls="${e.id}"], [aria-describedby="${e.id}"]`
    );
    return !t && !r2 && e.close(), e;
  }, 1);
}
function Tt(e) {
  e.state === "opened" ? e.close() : (this.trigger = e.trigger, e.open(), lt.call(this, e));
}
function St(e) {
  switch (e.key) {
    case "Escape":
      this.trigger && this.trigger.focus(), st2.call(this);
      return;
    case "Tab":
      this.collection.forEach((t) => {
        ct.call(this, t);
      });
      return;
    default:
      return;
  }
}
function lt(e) {
  const t = this;
  document.addEventListener("click", function r2(i2) {
    i2.target.closest(
      `#${e.id}, [aria-controls="${e.id}"], [aria-describedby="${e.id}"]`
    ) ? e.el && !e.el.classList.contains(t.settings.stateActive) && this.removeEventListener("click", r2) : (e.el && e.el.classList.contains(t.settings.stateActive) && e.close(), this.removeEventListener("click", r2));
  });
}
var k = "top", S2 = "bottom", j2 = "right", D = "left", De = "auto", le = [k, S2, j2, D], Q = "start", se = "end", jt = "clippingParents", ft = "viewport", ne = "popper", Mt = "reference", Ge = /* @__PURE__ */ le.reduce(function(e, t) {
  return e.concat([t + "-" + Q, t + "-" + se]);
}, []), ut = /* @__PURE__ */ [].concat(le, [De]).reduce(function(e, t) {
  return e.concat([t, t + "-" + Q, t + "-" + se]);
}, []), Wt = "beforeRead", Ht = "read", Nt = "afterRead", It = "beforeMain", Vt = "main", Ft = "afterMain", Xt = "beforeWrite", Yt = "write", qt = "afterWrite", zt = [Wt, Ht, Nt, It, Vt, Ft, Xt, Yt, qt];
function N(e) {
  return e ? (e.nodeName || "").toLowerCase() : null;
}
function B(e) {
  if (e == null)
    return window;
  if (e.toString() !== "[object Window]") {
    var t = e.ownerDocument;
    return t && t.defaultView || window;
  }
  return e;
}
function K(e) {
  var t = B(e).Element;
  return e instanceof t || e instanceof Element;
}
function T(e) {
  var t = B(e).HTMLElement;
  return e instanceof t || e instanceof HTMLElement;
}
function Re(e) {
  if (typeof ShadowRoot > "u")
    return false;
  var t = B(e).ShadowRoot;
  return e instanceof t || e instanceof ShadowRoot;
}
function Ut(e) {
  var t = e.state;
  Object.keys(t.elements).forEach(function(r2) {
    var i2 = t.styles[r2] || {}, n = t.attributes[r2] || {}, o2 = t.elements[r2];
    !T(o2) || !N(o2) || (Object.assign(o2.style, i2), Object.keys(n).forEach(function(l2) {
      var s = n[l2];
      s === false ? o2.removeAttribute(l2) : o2.setAttribute(l2, s === true ? "" : s);
    }));
  });
}
function _t(e) {
  var t = e.state, r2 = {
    popper: {
      position: t.options.strategy,
      left: "0",
      top: "0",
      margin: "0"
    },
    arrow: {
      position: "absolute"
    },
    reference: {}
  };
  return Object.assign(t.elements.popper.style, r2.popper), t.styles = r2, t.elements.arrow && Object.assign(t.elements.arrow.style, r2.arrow), function() {
    Object.keys(t.elements).forEach(function(i2) {
      var n = t.elements[i2], o2 = t.attributes[i2] || {}, l2 = Object.keys(t.styles.hasOwnProperty(i2) ? t.styles[i2] : r2[i2]), s = l2.reduce(function(a2, f2) {
        return a2[f2] = "", a2;
      }, {});
      !T(n) || !N(n) || (Object.assign(n.style, s), Object.keys(o2).forEach(function(a2) {
        n.removeAttribute(a2);
      }));
    });
  };
}
const Kt = {
  name: "applyStyles",
  enabled: true,
  phase: "write",
  fn: Ut,
  effect: _t,
  requires: ["computeStyles"]
};
function H(e) {
  return e.split("-")[0];
}
var _ = Math.max, ye = Math.min, Z = Math.round;
function Le() {
  var e = navigator.userAgentData;
  return e != null && e.brands && Array.isArray(e.brands) ? e.brands.map(function(t) {
    return t.brand + "/" + t.version;
  }).join(" ") : navigator.userAgent;
}
function pt() {
  return !/^((?!chrome|android).)*safari/i.test(Le());
}
function ee(e, t, r2) {
  t === void 0 && (t = false), r2 === void 0 && (r2 = false);
  var i2 = e.getBoundingClientRect(), n = 1, o2 = 1;
  t && T(e) && (n = e.offsetWidth > 0 && Z(i2.width) / e.offsetWidth || 1, o2 = e.offsetHeight > 0 && Z(i2.height) / e.offsetHeight || 1);
  var l2 = K(e) ? B(e) : window, s = l2.visualViewport, a2 = !pt() && r2, f2 = (i2.left + (a2 && s ? s.offsetLeft : 0)) / n, c2 = (i2.top + (a2 && s ? s.offsetTop : 0)) / o2, h2 = i2.width / n, y2 = i2.height / o2;
  return {
    width: h2,
    height: y2,
    top: c2,
    right: f2 + h2,
    bottom: c2 + y2,
    left: f2,
    x: f2,
    y: c2
  };
}
function Be(e) {
  var t = ee(e), r2 = e.offsetWidth, i2 = e.offsetHeight;
  return Math.abs(t.width - r2) <= 1 && (r2 = t.width), Math.abs(t.height - i2) <= 1 && (i2 = t.height), {
    x: e.offsetLeft,
    y: e.offsetTop,
    width: r2,
    height: i2
  };
}
function dt(e, t) {
  var r2 = t.getRootNode && t.getRootNode();
  if (e.contains(t))
    return true;
  if (r2 && Re(r2)) {
    var i2 = t;
    do {
      if (i2 && e.isSameNode(i2))
        return true;
      i2 = i2.parentNode || i2.host;
    } while (i2);
  }
  return false;
}
function I2(e) {
  return B(e).getComputedStyle(e);
}
function Gt(e) {
  return ["table", "td", "th"].indexOf(N(e)) >= 0;
}
function F(e) {
  return ((K(e) ? e.ownerDocument : (
    // $FlowFixMe[prop-missing]
    e.document
  )) || window.document).documentElement;
}
function we(e) {
  return N(e) === "html" ? e : (
    // this is a quicker (but less type safe) way to save quite some bytes from the bundle
    // $FlowFixMe[incompatible-return]
    // $FlowFixMe[prop-missing]
    e.assignedSlot || // step into the shadow DOM of the parent of a slotted node
    e.parentNode || // DOM Element detected
    (Re(e) ? e.host : null) || // ShadowRoot detected
    // $FlowFixMe[incompatible-call]: HTMLElement is a Node
    F(e)
  );
}
function Je(e) {
  return !T(e) || // https://github.com/popperjs/popper-core/issues/837
  I2(e).position === "fixed" ? null : e.offsetParent;
}
function Jt(e) {
  var t = /firefox/i.test(Le()), r2 = /Trident/i.test(Le());
  if (r2 && T(e)) {
    var i2 = I2(e);
    if (i2.position === "fixed")
      return null;
  }
  var n = we(e);
  for (Re(n) && (n = n.host); T(n) && ["html", "body"].indexOf(N(n)) < 0; ) {
    var o2 = I2(n);
    if (o2.transform !== "none" || o2.perspective !== "none" || o2.contain === "paint" || ["transform", "perspective"].indexOf(o2.willChange) !== -1 || t && o2.willChange === "filter" || t && o2.filter && o2.filter !== "none")
      return n;
    n = n.parentNode;
  }
  return null;
}
function fe(e) {
  for (var t = B(e), r2 = Je(e); r2 && Gt(r2) && I2(r2).position === "static"; )
    r2 = Je(r2);
  return r2 && (N(r2) === "html" || N(r2) === "body" && I2(r2).position === "static") ? t : r2 || Jt(e) || t;
}
function Te(e) {
  return ["top", "bottom"].indexOf(e) >= 0 ? "x" : "y";
}
function oe(e, t, r2) {
  return _(e, ye(t, r2));
}
function Qt(e, t, r2) {
  var i2 = oe(e, t, r2);
  return i2 > r2 ? r2 : i2;
}
function vt() {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  };
}
function ht(e) {
  return Object.assign({}, vt(), e);
}
function gt(e, t) {
  return t.reduce(function(r2, i2) {
    return r2[i2] = e, r2;
  }, {});
}
var Zt = function(t, r2) {
  return t = typeof t == "function" ? t(Object.assign({}, r2.rects, {
    placement: r2.placement
  })) : t, ht(typeof t != "number" ? t : gt(t, le));
};
function er(e) {
  var t, r2 = e.state, i2 = e.name, n = e.options, o2 = r2.elements.arrow, l2 = r2.modifiersData.popperOffsets, s = H(r2.placement), a2 = Te(s), f2 = [D, j2].indexOf(s) >= 0, c2 = f2 ? "height" : "width";
  if (!(!o2 || !l2)) {
    var h2 = Zt(n.padding, r2), y2 = Be(o2), u2 = a2 === "y" ? k : D, b2 = a2 === "y" ? S2 : j2, v2 = r2.rects.reference[c2] + r2.rects.reference[a2] - l2[a2] - r2.rects.popper[c2], d2 = l2[a2] - r2.rects.reference[a2], w2 = fe(o2), O2 = w2 ? a2 === "y" ? w2.clientHeight || 0 : w2.clientWidth || 0 : 0, E2 = v2 / 2 - d2 / 2, p2 = h2[u2], g2 = O2 - y2[c2] - h2[b2], m2 = O2 / 2 - y2[c2] / 2 + E2, x2 = oe(p2, m2, g2), L3 = a2;
    r2.modifiersData[i2] = (t = {}, t[L3] = x2, t.centerOffset = x2 - m2, t);
  }
}
function tr(e) {
  var t = e.state, r2 = e.options, i2 = r2.element, n = i2 === void 0 ? "[data-popper-arrow]" : i2;
  n != null && (typeof n == "string" && (n = t.elements.popper.querySelector(n), !n) || dt(t.elements.popper, n) && (t.elements.arrow = n));
}
const rr = {
  name: "arrow",
  enabled: true,
  phase: "main",
  fn: er,
  effect: tr,
  requires: ["popperOffsets"],
  requiresIfExists: ["preventOverflow"]
};
function te(e) {
  return e.split("-")[1];
}
var ir = {
  top: "auto",
  right: "auto",
  bottom: "auto",
  left: "auto"
};
function nr(e, t) {
  var r2 = e.x, i2 = e.y, n = t.devicePixelRatio || 1;
  return {
    x: Z(r2 * n) / n || 0,
    y: Z(i2 * n) / n || 0
  };
}
function Qe(e) {
  var t, r2 = e.popper, i2 = e.popperRect, n = e.placement, o2 = e.variation, l2 = e.offsets, s = e.position, a2 = e.gpuAcceleration, f2 = e.adaptive, c2 = e.roundOffsets, h2 = e.isFixed, y2 = l2.x, u2 = y2 === void 0 ? 0 : y2, b2 = l2.y, v2 = b2 === void 0 ? 0 : b2, d2 = typeof c2 == "function" ? c2({
    x: u2,
    y: v2
  }) : {
    x: u2,
    y: v2
  };
  u2 = d2.x, v2 = d2.y;
  var w2 = l2.hasOwnProperty("x"), O2 = l2.hasOwnProperty("y"), E2 = D, p2 = k, g2 = window;
  if (f2) {
    var m2 = fe(r2), x2 = "clientHeight", L3 = "clientWidth";
    if (m2 === B(r2) && (m2 = F(r2), I2(m2).position !== "static" && s === "absolute" && (x2 = "scrollHeight", L3 = "scrollWidth")), m2 = m2, n === k || (n === D || n === j2) && o2 === se) {
      p2 = S2;
      var P3 = h2 && m2 === g2 && g2.visualViewport ? g2.visualViewport.height : (
        // $FlowFixMe[prop-missing]
        m2[x2]
      );
      v2 -= P3 - i2.height, v2 *= a2 ? 1 : -1;
    }
    if (n === D || (n === k || n === S2) && o2 === se) {
      E2 = j2;
      var A3 = h2 && m2 === g2 && g2.visualViewport ? g2.visualViewport.width : (
        // $FlowFixMe[prop-missing]
        m2[L3]
      );
      u2 -= A3 - i2.width, u2 *= a2 ? 1 : -1;
    }
  }
  var $2 = Object.assign({
    position: s
  }, f2 && ir), M2 = c2 === true ? nr({
    x: u2,
    y: v2
  }, B(r2)) : {
    x: u2,
    y: v2
  };
  if (u2 = M2.x, v2 = M2.y, a2) {
    var C2;
    return Object.assign({}, $2, (C2 = {}, C2[p2] = O2 ? "0" : "", C2[E2] = w2 ? "0" : "", C2.transform = (g2.devicePixelRatio || 1) <= 1 ? "translate(" + u2 + "px, " + v2 + "px)" : "translate3d(" + u2 + "px, " + v2 + "px, 0)", C2));
  }
  return Object.assign({}, $2, (t = {}, t[p2] = O2 ? v2 + "px" : "", t[E2] = w2 ? u2 + "px" : "", t.transform = "", t));
}
function or(e) {
  var t = e.state, r2 = e.options, i2 = r2.gpuAcceleration, n = i2 === void 0 ? true : i2, o2 = r2.adaptive, l2 = o2 === void 0 ? true : o2, s = r2.roundOffsets, a2 = s === void 0 ? true : s, f2 = {
    placement: H(t.placement),
    variation: te(t.placement),
    popper: t.elements.popper,
    popperRect: t.rects.popper,
    gpuAcceleration: n,
    isFixed: t.options.strategy === "fixed"
  };
  t.modifiersData.popperOffsets != null && (t.styles.popper = Object.assign({}, t.styles.popper, Qe(Object.assign({}, f2, {
    offsets: t.modifiersData.popperOffsets,
    position: t.options.strategy,
    adaptive: l2,
    roundOffsets: a2
  })))), t.modifiersData.arrow != null && (t.styles.arrow = Object.assign({}, t.styles.arrow, Qe(Object.assign({}, f2, {
    offsets: t.modifiersData.arrow,
    position: "absolute",
    adaptive: false,
    roundOffsets: a2
  })))), t.attributes.popper = Object.assign({}, t.attributes.popper, {
    "data-popper-placement": t.placement
  });
}
const ar = {
  name: "computeStyles",
  enabled: true,
  phase: "beforeWrite",
  fn: or,
  data: {}
};
var ge = {
  passive: true
};
function sr(e) {
  var t = e.state, r2 = e.instance, i2 = e.options, n = i2.scroll, o2 = n === void 0 ? true : n, l2 = i2.resize, s = l2 === void 0 ? true : l2, a2 = B(t.elements.popper), f2 = [].concat(t.scrollParents.reference, t.scrollParents.popper);
  return o2 && f2.forEach(function(c2) {
    c2.addEventListener("scroll", r2.update, ge);
  }), s && a2.addEventListener("resize", r2.update, ge), function() {
    o2 && f2.forEach(function(c2) {
      c2.removeEventListener("scroll", r2.update, ge);
    }), s && a2.removeEventListener("resize", r2.update, ge);
  };
}
const cr = {
  name: "eventListeners",
  enabled: true,
  phase: "write",
  fn: function() {
  },
  effect: sr,
  data: {}
};
var lr = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
};
function me(e) {
  return e.replace(/left|right|bottom|top/g, function(t) {
    return lr[t];
  });
}
var fr = {
  start: "end",
  end: "start"
};
function Ze(e) {
  return e.replace(/start|end/g, function(t) {
    return fr[t];
  });
}
function Se(e) {
  var t = B(e), r2 = t.pageXOffset, i2 = t.pageYOffset;
  return {
    scrollLeft: r2,
    scrollTop: i2
  };
}
function je(e) {
  return ee(F(e)).left + Se(e).scrollLeft;
}
function ur(e, t) {
  var r2 = B(e), i2 = F(e), n = r2.visualViewport, o2 = i2.clientWidth, l2 = i2.clientHeight, s = 0, a2 = 0;
  if (n) {
    o2 = n.width, l2 = n.height;
    var f2 = pt();
    (f2 || !f2 && t === "fixed") && (s = n.offsetLeft, a2 = n.offsetTop);
  }
  return {
    width: o2,
    height: l2,
    x: s + je(e),
    y: a2
  };
}
function pr(e) {
  var t, r2 = F(e), i2 = Se(e), n = (t = e.ownerDocument) == null ? void 0 : t.body, o2 = _(r2.scrollWidth, r2.clientWidth, n ? n.scrollWidth : 0, n ? n.clientWidth : 0), l2 = _(r2.scrollHeight, r2.clientHeight, n ? n.scrollHeight : 0, n ? n.clientHeight : 0), s = -i2.scrollLeft + je(e), a2 = -i2.scrollTop;
  return I2(n || r2).direction === "rtl" && (s += _(r2.clientWidth, n ? n.clientWidth : 0) - o2), {
    width: o2,
    height: l2,
    x: s,
    y: a2
  };
}
function Me(e) {
  var t = I2(e), r2 = t.overflow, i2 = t.overflowX, n = t.overflowY;
  return /auto|scroll|overlay|hidden/.test(r2 + n + i2);
}
function mt(e) {
  return ["html", "body", "#document"].indexOf(N(e)) >= 0 ? e.ownerDocument.body : T(e) && Me(e) ? e : mt(we(e));
}
function ae(e, t) {
  var r2;
  t === void 0 && (t = []);
  var i2 = mt(e), n = i2 === ((r2 = e.ownerDocument) == null ? void 0 : r2.body), o2 = B(i2), l2 = n ? [o2].concat(o2.visualViewport || [], Me(i2) ? i2 : []) : i2, s = t.concat(l2);
  return n ? s : (
    // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
    s.concat(ae(we(l2)))
  );
}
function $e(e) {
  return Object.assign({}, e, {
    left: e.x,
    top: e.y,
    right: e.x + e.width,
    bottom: e.y + e.height
  });
}
function dr(e, t) {
  var r2 = ee(e, false, t === "fixed");
  return r2.top = r2.top + e.clientTop, r2.left = r2.left + e.clientLeft, r2.bottom = r2.top + e.clientHeight, r2.right = r2.left + e.clientWidth, r2.width = e.clientWidth, r2.height = e.clientHeight, r2.x = r2.left, r2.y = r2.top, r2;
}
function et(e, t, r2) {
  return t === ft ? $e(ur(e, r2)) : K(t) ? dr(t, r2) : $e(pr(F(e)));
}
function vr(e) {
  var t = ae(we(e)), r2 = ["absolute", "fixed"].indexOf(I2(e).position) >= 0, i2 = r2 && T(e) ? fe(e) : e;
  return K(i2) ? t.filter(function(n) {
    return K(n) && dt(n, i2) && N(n) !== "body";
  }) : [];
}
function hr(e, t, r2, i2) {
  var n = t === "clippingParents" ? vr(e) : [].concat(t), o2 = [].concat(n, [r2]), l2 = o2[0], s = o2.reduce(function(a2, f2) {
    var c2 = et(e, f2, i2);
    return a2.top = _(c2.top, a2.top), a2.right = ye(c2.right, a2.right), a2.bottom = ye(c2.bottom, a2.bottom), a2.left = _(c2.left, a2.left), a2;
  }, et(e, l2, i2));
  return s.width = s.right - s.left, s.height = s.bottom - s.top, s.x = s.left, s.y = s.top, s;
}
function yt(e) {
  var t = e.reference, r2 = e.element, i2 = e.placement, n = i2 ? H(i2) : null, o2 = i2 ? te(i2) : null, l2 = t.x + t.width / 2 - r2.width / 2, s = t.y + t.height / 2 - r2.height / 2, a2;
  switch (n) {
    case k:
      a2 = {
        x: l2,
        y: t.y - r2.height
      };
      break;
    case S2:
      a2 = {
        x: l2,
        y: t.y + t.height
      };
      break;
    case j2:
      a2 = {
        x: t.x + t.width,
        y: s
      };
      break;
    case D:
      a2 = {
        x: t.x - r2.width,
        y: s
      };
      break;
    default:
      a2 = {
        x: t.x,
        y: t.y
      };
  }
  var f2 = n ? Te(n) : null;
  if (f2 != null) {
    var c2 = f2 === "y" ? "height" : "width";
    switch (o2) {
      case Q:
        a2[f2] = a2[f2] - (t[c2] / 2 - r2[c2] / 2);
        break;
      case se:
        a2[f2] = a2[f2] + (t[c2] / 2 - r2[c2] / 2);
        break;
    }
  }
  return a2;
}
function ce(e, t) {
  t === void 0 && (t = {});
  var r2 = t, i2 = r2.placement, n = i2 === void 0 ? e.placement : i2, o2 = r2.strategy, l2 = o2 === void 0 ? e.strategy : o2, s = r2.boundary, a2 = s === void 0 ? jt : s, f2 = r2.rootBoundary, c2 = f2 === void 0 ? ft : f2, h2 = r2.elementContext, y2 = h2 === void 0 ? ne : h2, u2 = r2.altBoundary, b2 = u2 === void 0 ? false : u2, v2 = r2.padding, d2 = v2 === void 0 ? 0 : v2, w2 = ht(typeof d2 != "number" ? d2 : gt(d2, le)), O2 = y2 === ne ? Mt : ne, E2 = e.rects.popper, p2 = e.elements[b2 ? O2 : y2], g2 = hr(K(p2) ? p2 : p2.contextElement || F(e.elements.popper), a2, c2, l2), m2 = ee(e.elements.reference), x2 = yt({
    reference: m2,
    element: E2,
    strategy: "absolute",
    placement: n
  }), L3 = $e(Object.assign({}, E2, x2)), P3 = y2 === ne ? L3 : m2, A3 = {
    top: g2.top - P3.top + w2.top,
    bottom: P3.bottom - g2.bottom + w2.bottom,
    left: g2.left - P3.left + w2.left,
    right: P3.right - g2.right + w2.right
  }, $2 = e.modifiersData.offset;
  if (y2 === ne && $2) {
    var M2 = $2[n];
    Object.keys(A3).forEach(function(C2) {
      var X2 = [j2, S2].indexOf(C2) >= 0 ? 1 : -1, Y2 = [k, S2].indexOf(C2) >= 0 ? "y" : "x";
      A3[C2] += M2[Y2] * X2;
    });
  }
  return A3;
}
function gr(e, t) {
  t === void 0 && (t = {});
  var r2 = t, i2 = r2.placement, n = r2.boundary, o2 = r2.rootBoundary, l2 = r2.padding, s = r2.flipVariations, a2 = r2.allowedAutoPlacements, f2 = a2 === void 0 ? ut : a2, c2 = te(i2), h2 = c2 ? s ? Ge : Ge.filter(function(b2) {
    return te(b2) === c2;
  }) : le, y2 = h2.filter(function(b2) {
    return f2.indexOf(b2) >= 0;
  });
  y2.length === 0 && (y2 = h2);
  var u2 = y2.reduce(function(b2, v2) {
    return b2[v2] = ce(e, {
      placement: v2,
      boundary: n,
      rootBoundary: o2,
      padding: l2
    })[H(v2)], b2;
  }, {});
  return Object.keys(u2).sort(function(b2, v2) {
    return u2[b2] - u2[v2];
  });
}
function mr(e) {
  if (H(e) === De)
    return [];
  var t = me(e);
  return [Ze(e), t, Ze(t)];
}
function yr(e) {
  var t = e.state, r2 = e.options, i2 = e.name;
  if (!t.modifiersData[i2]._skip) {
    for (var n = r2.mainAxis, o2 = n === void 0 ? true : n, l2 = r2.altAxis, s = l2 === void 0 ? true : l2, a2 = r2.fallbackPlacements, f2 = r2.padding, c2 = r2.boundary, h2 = r2.rootBoundary, y2 = r2.altBoundary, u2 = r2.flipVariations, b2 = u2 === void 0 ? true : u2, v2 = r2.allowedAutoPlacements, d2 = t.options.placement, w2 = H(d2), O2 = w2 === d2, E2 = a2 || (O2 || !b2 ? [me(d2)] : mr(d2)), p2 = [d2].concat(E2).reduce(function(G2, V2) {
      return G2.concat(H(V2) === De ? gr(t, {
        placement: V2,
        boundary: c2,
        rootBoundary: h2,
        padding: f2,
        flipVariations: b2,
        allowedAutoPlacements: v2
      }) : V2);
    }, []), g2 = t.rects.reference, m2 = t.rects.popper, x2 = /* @__PURE__ */ new Map(), L3 = true, P3 = p2[0], A3 = 0; A3 < p2.length; A3++) {
      var $2 = p2[A3], M2 = H($2), C2 = te($2) === Q, X2 = [k, S2].indexOf(M2) >= 0, Y2 = X2 ? "width" : "height", R2 = ce(t, {
        placement: $2,
        boundary: c2,
        rootBoundary: h2,
        altBoundary: y2,
        padding: f2
      }), W2 = X2 ? C2 ? j2 : D : C2 ? S2 : k;
      g2[Y2] > m2[Y2] && (W2 = me(W2));
      var ue = me(W2), q2 = [];
      if (o2 && q2.push(R2[M2] <= 0), s && q2.push(R2[W2] <= 0, R2[ue] <= 0), q2.every(function(G2) {
        return G2;
      })) {
        P3 = $2, L3 = false;
        break;
      }
      x2.set($2, q2);
    }
    if (L3)
      for (var pe = b2 ? 3 : 1, be = function(V2) {
        var ie = p2.find(function(ve) {
          var z2 = x2.get(ve);
          if (z2)
            return z2.slice(0, V2).every(function(xe) {
              return xe;
            });
        });
        if (ie)
          return P3 = ie, "break";
      }, re = pe; re > 0; re--) {
        var de = be(re);
        if (de === "break")
          break;
      }
    t.placement !== P3 && (t.modifiersData[i2]._skip = true, t.placement = P3, t.reset = true);
  }
}
const wr = {
  name: "flip",
  enabled: true,
  phase: "main",
  fn: yr,
  requiresIfExists: ["offset"],
  data: {
    _skip: false
  }
};
function tt(e, t, r2) {
  return r2 === void 0 && (r2 = {
    x: 0,
    y: 0
  }), {
    top: e.top - t.height - r2.y,
    right: e.right - t.width + r2.x,
    bottom: e.bottom - t.height + r2.y,
    left: e.left - t.width - r2.x
  };
}
function rt(e) {
  return [k, j2, S2, D].some(function(t) {
    return e[t] >= 0;
  });
}
function br(e) {
  var t = e.state, r2 = e.name, i2 = t.rects.reference, n = t.rects.popper, o2 = t.modifiersData.preventOverflow, l2 = ce(t, {
    elementContext: "reference"
  }), s = ce(t, {
    altBoundary: true
  }), a2 = tt(l2, i2), f2 = tt(s, n, o2), c2 = rt(a2), h2 = rt(f2);
  t.modifiersData[r2] = {
    referenceClippingOffsets: a2,
    popperEscapeOffsets: f2,
    isReferenceHidden: c2,
    hasPopperEscaped: h2
  }, t.attributes.popper = Object.assign({}, t.attributes.popper, {
    "data-popper-reference-hidden": c2,
    "data-popper-escaped": h2
  });
}
const xr = {
  name: "hide",
  enabled: true,
  phase: "main",
  requiresIfExists: ["preventOverflow"],
  fn: br
};
function Or(e, t, r2) {
  var i2 = H(e), n = [D, k].indexOf(i2) >= 0 ? -1 : 1, o2 = typeof r2 == "function" ? r2(Object.assign({}, t, {
    placement: e
  })) : r2, l2 = o2[0], s = o2[1];
  return l2 = l2 || 0, s = (s || 0) * n, [D, j2].indexOf(i2) >= 0 ? {
    x: s,
    y: l2
  } : {
    x: l2,
    y: s
  };
}
function Er(e) {
  var t = e.state, r2 = e.options, i2 = e.name, n = r2.offset, o2 = n === void 0 ? [0, 0] : n, l2 = ut.reduce(function(c2, h2) {
    return c2[h2] = Or(h2, t.rects, o2), c2;
  }, {}), s = l2[t.placement], a2 = s.x, f2 = s.y;
  t.modifiersData.popperOffsets != null && (t.modifiersData.popperOffsets.x += a2, t.modifiersData.popperOffsets.y += f2), t.modifiersData[i2] = l2;
}
const Ar = {
  name: "offset",
  enabled: true,
  phase: "main",
  requires: ["popperOffsets"],
  fn: Er
};
function Pr(e) {
  var t = e.state, r2 = e.name;
  t.modifiersData[r2] = yt({
    reference: t.rects.reference,
    element: t.rects.popper,
    strategy: "absolute",
    placement: t.placement
  });
}
const Lr = {
  name: "popperOffsets",
  enabled: true,
  phase: "read",
  fn: Pr,
  data: {}
};
function $r(e) {
  return e === "x" ? "y" : "x";
}
function Cr(e) {
  var t = e.state, r2 = e.options, i2 = e.name, n = r2.mainAxis, o2 = n === void 0 ? true : n, l2 = r2.altAxis, s = l2 === void 0 ? false : l2, a2 = r2.boundary, f2 = r2.rootBoundary, c2 = r2.altBoundary, h2 = r2.padding, y2 = r2.tether, u2 = y2 === void 0 ? true : y2, b2 = r2.tetherOffset, v2 = b2 === void 0 ? 0 : b2, d2 = ce(t, {
    boundary: a2,
    rootBoundary: f2,
    padding: h2,
    altBoundary: c2
  }), w2 = H(t.placement), O2 = te(t.placement), E2 = !O2, p2 = Te(w2), g2 = $r(p2), m2 = t.modifiersData.popperOffsets, x2 = t.rects.reference, L3 = t.rects.popper, P3 = typeof v2 == "function" ? v2(Object.assign({}, t.rects, {
    placement: t.placement
  })) : v2, A3 = typeof P3 == "number" ? {
    mainAxis: P3,
    altAxis: P3
  } : Object.assign({
    mainAxis: 0,
    altAxis: 0
  }, P3), $2 = t.modifiersData.offset ? t.modifiersData.offset[t.placement] : null, M2 = {
    x: 0,
    y: 0
  };
  if (m2) {
    if (o2) {
      var C2, X2 = p2 === "y" ? k : D, Y2 = p2 === "y" ? S2 : j2, R2 = p2 === "y" ? "height" : "width", W2 = m2[p2], ue = W2 + d2[X2], q2 = W2 - d2[Y2], pe = u2 ? -L3[R2] / 2 : 0, be = O2 === Q ? x2[R2] : L3[R2], re = O2 === Q ? -L3[R2] : -x2[R2], de = t.elements.arrow, G2 = u2 && de ? Be(de) : {
        width: 0,
        height: 0
      }, V2 = t.modifiersData["arrow#persistent"] ? t.modifiersData["arrow#persistent"].padding : vt(), ie = V2[X2], ve = V2[Y2], z2 = oe(0, x2[R2], G2[R2]), xe = E2 ? x2[R2] / 2 - pe - z2 - ie - A3.mainAxis : be - z2 - ie - A3.mainAxis, xt = E2 ? -x2[R2] / 2 + pe + z2 + ve + A3.mainAxis : re + z2 + ve + A3.mainAxis, Oe = t.elements.arrow && fe(t.elements.arrow), Ot = Oe ? p2 === "y" ? Oe.clientTop || 0 : Oe.clientLeft || 0 : 0, He = (C2 = $2 == null ? void 0 : $2[p2]) != null ? C2 : 0, Et = W2 + xe - He - Ot, At = W2 + xt - He, Ne = oe(u2 ? ye(ue, Et) : ue, W2, u2 ? _(q2, At) : q2);
      m2[p2] = Ne, M2[p2] = Ne - W2;
    }
    if (s) {
      var Ie, Pt = p2 === "x" ? k : D, Lt = p2 === "x" ? S2 : j2, U2 = m2[g2], he = g2 === "y" ? "height" : "width", Ve = U2 + d2[Pt], Fe = U2 - d2[Lt], Ee = [k, D].indexOf(w2) !== -1, Xe = (Ie = $2 == null ? void 0 : $2[g2]) != null ? Ie : 0, Ye = Ee ? Ve : U2 - x2[he] - L3[he] - Xe + A3.altAxis, qe = Ee ? U2 + x2[he] + L3[he] - Xe - A3.altAxis : Fe, ze = u2 && Ee ? Qt(Ye, U2, qe) : oe(u2 ? Ye : Ve, U2, u2 ? qe : Fe);
      m2[g2] = ze, M2[g2] = ze - U2;
    }
    t.modifiersData[i2] = M2;
  }
}
const kr = {
  name: "preventOverflow",
  enabled: true,
  phase: "main",
  fn: Cr,
  requiresIfExists: ["offset"]
};
function Dr(e) {
  return {
    scrollLeft: e.scrollLeft,
    scrollTop: e.scrollTop
  };
}
function Rr(e) {
  return e === B(e) || !T(e) ? Se(e) : Dr(e);
}
function Br(e) {
  var t = e.getBoundingClientRect(), r2 = Z(t.width) / e.offsetWidth || 1, i2 = Z(t.height) / e.offsetHeight || 1;
  return r2 !== 1 || i2 !== 1;
}
function Tr(e, t, r2) {
  r2 === void 0 && (r2 = false);
  var i2 = T(t), n = T(t) && Br(t), o2 = F(t), l2 = ee(e, n, r2), s = {
    scrollLeft: 0,
    scrollTop: 0
  }, a2 = {
    x: 0,
    y: 0
  };
  return (i2 || !i2 && !r2) && ((N(t) !== "body" || // https://github.com/popperjs/popper-core/issues/1078
  Me(o2)) && (s = Rr(t)), T(t) ? (a2 = ee(t, true), a2.x += t.clientLeft, a2.y += t.clientTop) : o2 && (a2.x = je(o2))), {
    x: l2.left + s.scrollLeft - a2.x,
    y: l2.top + s.scrollTop - a2.y,
    width: l2.width,
    height: l2.height
  };
}
function Sr(e) {
  var t = /* @__PURE__ */ new Map(), r2 = /* @__PURE__ */ new Set(), i2 = [];
  e.forEach(function(o2) {
    t.set(o2.name, o2);
  });
  function n(o2) {
    r2.add(o2.name);
    var l2 = [].concat(o2.requires || [], o2.requiresIfExists || []);
    l2.forEach(function(s) {
      if (!r2.has(s)) {
        var a2 = t.get(s);
        a2 && n(a2);
      }
    }), i2.push(o2);
  }
  return e.forEach(function(o2) {
    r2.has(o2.name) || n(o2);
  }), i2;
}
function jr(e) {
  var t = Sr(e);
  return zt.reduce(function(r2, i2) {
    return r2.concat(t.filter(function(n) {
      return n.phase === i2;
    }));
  }, []);
}
function Mr(e) {
  var t;
  return function() {
    return t || (t = new Promise(function(r2) {
      Promise.resolve().then(function() {
        t = void 0, r2(e());
      });
    })), t;
  };
}
function Wr(e) {
  var t = e.reduce(function(r2, i2) {
    var n = r2[i2.name];
    return r2[i2.name] = n ? Object.assign({}, n, i2, {
      options: Object.assign({}, n.options, i2.options),
      data: Object.assign({}, n.data, i2.data)
    }) : i2, r2;
  }, {});
  return Object.keys(t).map(function(r2) {
    return t[r2];
  });
}
var it = {
  placement: "bottom",
  modifiers: [],
  strategy: "absolute"
};
function nt() {
  for (var e = arguments.length, t = new Array(e), r2 = 0; r2 < e; r2++)
    t[r2] = arguments[r2];
  return !t.some(function(i2) {
    return !(i2 && typeof i2.getBoundingClientRect == "function");
  });
}
function Hr(e) {
  e === void 0 && (e = {});
  var t = e, r2 = t.defaultModifiers, i2 = r2 === void 0 ? [] : r2, n = t.defaultOptions, o2 = n === void 0 ? it : n;
  return function(s, a2, f2) {
    f2 === void 0 && (f2 = o2);
    var c2 = {
      placement: "bottom",
      orderedModifiers: [],
      options: Object.assign({}, it, o2),
      modifiersData: {},
      elements: {
        reference: s,
        popper: a2
      },
      attributes: {},
      styles: {}
    }, h2 = [], y2 = false, u2 = {
      state: c2,
      setOptions: function(w2) {
        var O2 = typeof w2 == "function" ? w2(c2.options) : w2;
        v2(), c2.options = Object.assign({}, o2, c2.options, O2), c2.scrollParents = {
          reference: K(s) ? ae(s) : s.contextElement ? ae(s.contextElement) : [],
          popper: ae(a2)
        };
        var E2 = jr(Wr([].concat(i2, c2.options.modifiers)));
        return c2.orderedModifiers = E2.filter(function(p2) {
          return p2.enabled;
        }), b2(), u2.update();
      },
      // Sync update – it will always be executed, even if not necessary. This
      // is useful for low frequency updates where sync behavior simplifies the
      // logic.
      // For high frequency updates (e.g. `resize` and `scroll` events), always
      // prefer the async Popper#update method
      forceUpdate: function() {
        if (!y2) {
          var w2 = c2.elements, O2 = w2.reference, E2 = w2.popper;
          if (nt(O2, E2)) {
            c2.rects = {
              reference: Tr(O2, fe(E2), c2.options.strategy === "fixed"),
              popper: Be(E2)
            }, c2.reset = false, c2.placement = c2.options.placement, c2.orderedModifiers.forEach(function(A3) {
              return c2.modifiersData[A3.name] = Object.assign({}, A3.data);
            });
            for (var p2 = 0; p2 < c2.orderedModifiers.length; p2++) {
              if (c2.reset === true) {
                c2.reset = false, p2 = -1;
                continue;
              }
              var g2 = c2.orderedModifiers[p2], m2 = g2.fn, x2 = g2.options, L3 = x2 === void 0 ? {} : x2, P3 = g2.name;
              typeof m2 == "function" && (c2 = m2({
                state: c2,
                options: L3,
                name: P3,
                instance: u2
              }) || c2);
            }
          }
        }
      },
      // Async and optimistically optimized update – it will not be executed if
      // not necessary (debounced to run at most once-per-tick)
      update: Mr(function() {
        return new Promise(function(d2) {
          u2.forceUpdate(), d2(c2);
        });
      }),
      destroy: function() {
        v2(), y2 = true;
      }
    };
    if (!nt(s, a2))
      return u2;
    u2.setOptions(f2).then(function(d2) {
      !y2 && f2.onFirstUpdate && f2.onFirstUpdate(d2);
    });
    function b2() {
      c2.orderedModifiers.forEach(function(d2) {
        var w2 = d2.name, O2 = d2.options, E2 = O2 === void 0 ? {} : O2, p2 = d2.effect;
        if (typeof p2 == "function") {
          var g2 = p2({
            state: c2,
            name: w2,
            instance: u2,
            options: E2
          }), m2 = function() {
          };
          h2.push(g2 || m2);
        }
      });
    }
    function v2() {
      h2.forEach(function(d2) {
        return d2();
      }), h2 = [];
    }
    return u2;
  };
}
var Nr = [cr, Lr, ar, Kt, Ar, wr, kr, rr, xr], Ir = /* @__PURE__ */ Hr({
  defaultModifiers: Nr
});
async function Ce(e) {
  const t = this.collection.findIndex((r2) => r2.id === e.id);
  if (t >= 0) {
    const r2 = this.collection[t];
    r2.state === "opened" && r2.close(), r2.popper.destroy(), wt(r2), Object.getOwnPropertyNames(r2).forEach((i2) => {
      delete r2[i2];
    }), this.collection.splice(t, 1);
  }
  return this.collection;
}
function wt(e) {
  return e.__eventListeners && (e.__eventListeners.forEach((t) => {
    t.el.forEach((r2) => {
      t.type.forEach((i2) => {
        e[r2].removeEventListener(i2, t.listener, false);
      });
    });
  }), delete e.__eventListeners), e;
}
async function We(e) {
  const t = at.call(this, e);
  return t.el.classList.add(this.settings.stateActive), t.trigger.hasAttribute("aria-controls") && t.trigger.setAttribute("aria-expanded", "true"), t.config = ot(t.el, this.settings), t.popper.setOptions({
    placement: t.config.placement,
    modifiers: [
      { name: "eventListeners", enabled: true },
      ...Dt(t.config)
    ]
  }), t.popper.update(), t.state = "opened", t;
}
async function Vr(e, t) {
  Ce.call(this, e);
  const r2 = this, i2 = {
    id: e.id,
    state: "closed",
    el: e,
    trigger: t,
    popper: Ir(t, e),
    config: ot(e, this.settings),
    open() {
      return We.call(r2, this);
    },
    close() {
      return ke.call(r2, this);
    },
    deregister() {
      return Ce.call(r2, this);
    }
  };
  return i2.trigger.hasAttribute("aria-controls") && i2.trigger.setAttribute("aria-expanded", "false"), bt.call(this, i2), this.collection.push(i2), i2.el.classList.contains(this.settings.stateActive) && (await i2.open(), lt.call(this, i2)), i2;
}
function bt(e) {
  return e.__eventListeners || (e.config.event === "hover" ? (e.__eventListeners = [{
    el: ["trigger"],
    type: ["mouseenter", "focus"],
    listener: We.bind(this, e)
  }, {
    el: ["el", "trigger"],
    type: ["mouseleave", "focusout"],
    listener: ct.bind(this, e)
  }], e.__eventListeners.forEach((r2) => {
    r2.el.forEach((i2) => {
      r2.type.forEach((n) => {
        e[i2].addEventListener(n, r2.listener, false);
      });
    });
  })) : (e.__eventListeners = [{
    el: ["trigger"],
    type: ["click"],
    listener: Tt.bind(this, e)
  }], e.__eventListeners.forEach((r2) => {
    r2.el.forEach((i2) => {
      r2.type.forEach((n) => {
        e[i2].addEventListener(n, r2.listener, false);
      });
    });
  }))), e;
}
var J2;
class Xr extends $t {
  constructor(r2) {
    super();
    _e(this, J2, void 0);
    this.defaults = kt, this.settings = { ...this.defaults, ...r2 }, this.trigger = null, Ke(this, J2, St.bind(this)), this.settings.autoInit && this.init();
  }
  async init(r2) {
    r2 && (this.settings = { ...this.settings, ...r2 });
    const i2 = document.querySelectorAll(this.settings.selectorPopover);
    return await this.registerCollection(i2), this.settings.eventListeners && this.initEventListeners(false), this;
  }
  async destroy() {
    return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(false), this;
  }
  initEventListeners(r2 = true) {
    r2 && this.collection.forEach((i2) => {
      bt.call(this, i2);
    }), document.addEventListener("keydown", Ae(this, J2), false);
  }
  destroyEventListeners(r2 = true) {
    r2 && this.collection.forEach((i2) => {
      wt(i2);
    }), document.removeEventListener("keydown", Ae(this, J2), false);
  }
  register(r2) {
    const i2 = Bt.call(this, r2);
    return i2.error ? Promise.reject(i2.error) : Vr.call(this, i2.popover, i2.trigger);
  }
  deregister(r2) {
    let i2 = this.get(r2.id || r2);
    return i2 ? Ce.call(this, i2) : Promise.reject(new Error(`Failed to deregister; popover does not exist in collection with ID of: "${r2.id || r2}".`));
  }
  open(r2) {
    return We.call(this, r2);
  }
  close(r2) {
    return ke.call(this, r2);
  }
}
J2 = /* @__PURE__ */ new WeakMap();
export {
  st$1 as Drawer,
  J$1 as Modal,
  Xr as Popover,
  index as core
};
//# sourceMappingURL=index.js.map
