var ze = (e, t, n) => {
  if (!t.has(e))
    throw TypeError("Cannot " + n);
}, j = (e, t, n) => (ze(e, t, "read from private field"), n ? n.call(e) : t.get(e)), Rt = (e, t, n) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, n);
}, nt = (e, t, n, i) => (ze(e, t, "write to private field"), i ? i.call(e, n) : t.set(e, n), n), V;
let In = class {
  constructor(t, n) {
    Rt(this, V, void 0), this.value = t, nt(this, V, n), this.mql = null;
  }
  get handler() {
    return j(this, V);
  }
  // Unmount existing handler before setting a new one.
  set handler(t) {
    this.mql && this.mql.removeEventListener("change", j(this, V)), nt(this, V, t);
  }
  mount(t, n) {
    return t && (this.value = t), n && nt(this, V, n), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), this.mql.addEventListener("change", j(this, V)), j(this, V).call(this, this.mql), this) : this;
  }
  unmount() {
    return this.mql ? (this.mql.removeEventListener("change", j(this, V)), this.value = null, nt(this, V, null), this.mql = null, this) : this;
  }
};
V = /* @__PURE__ */ new WeakMap();
let An = class {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const n = this.collection.findIndex((i) => i === t);
    if (n >= 0) {
      const i = this.collection[n];
      Object.getOwnPropertyNames(i).forEach((r) => {
        delete i[r];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, n = "id") {
    return this.collection.find((i) => i[n] === t);
  }
};
const p = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, Pn = [
  `a[href]${p.inert}${p.negTabIndex}`,
  `area[href]${p.inert}${p.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${p.inert}${p.negTabIndex}${p.disabled}`,
  `input[type="radio"]${p.inert}${p.negTabIndex}${p.disabled}`,
  `select${p.inert}${p.negTabIndex}${p.disabled}`,
  `textarea${p.inert}${p.negTabIndex}${p.disabled}`,
  `button${p.inert}${p.negTabIndex}${p.disabled}`,
  `details${p.inert} > summary:first-of-type${p.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${p.inert}${p.negTabIndex}`,
  `audio[controls]${p.inert}${p.negTabIndex}`,
  `video[controls]${p.inert}${p.negTabIndex}`,
  `[contenteditable]${p.inert}${p.negTabIndex}`,
  `[tabindex]${p.inert}${p.negTabIndex}`
];
var wt, at, lt;
let Dn = class {
  constructor(t = null, n = "[data-focus]") {
    Rt(this, wt, void 0), Rt(this, at, void 0), Rt(this, lt, void 0), this.el = t, this.selectorFocus = n, nt(this, at, Mn.bind(this)), nt(this, lt, jn.bind(this));
  }
  get focusable() {
    return j(this, wt);
  }
  set focusable(t) {
    nt(this, wt, t), j(this, wt).length ? (document.removeEventListener("keydown", j(this, lt)), document.addEventListener("keydown", j(this, at))) : (document.removeEventListener("keydown", j(this, at)), document.addEventListener("keydown", j(this, lt)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(t, n) {
    t && (this.el = t), n && (this.selectorFocus = n), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", j(this, at)), document.removeEventListener("keydown", j(this, lt));
  }
  focus(t = this.el, n = this.selectorFocus) {
    (t.querySelector(n) || t).focus();
  }
  getFocusable(t = this.el) {
    const n = [], i = document.activeElement, r = t.scrollTop;
    return t.querySelectorAll(Pn.join(",")).forEach((s) => {
      s.focus(), document.activeElement === s && n.push(s);
    }), t.scrollTop = r, i.focus(), n;
  }
};
wt = /* @__PURE__ */ new WeakMap(), at = /* @__PURE__ */ new WeakMap(), lt = /* @__PURE__ */ new WeakMap();
function Mn(e) {
  (e.key === "Tab" || e.keyCode === 9) && (e.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (e.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (e.preventDefault(), this.focusableFirst.focus()));
}
function jn(e) {
  (e.key === "Tab" || e.keyCode === 9) && e.preventDefault();
}
function Ke() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-prefix").trim();
}
function Ge(e, t = document.body, n = !0) {
  if (n) {
    const r = Ke();
    r && !e.includes(`--${r}`) && (e = e.replace("--", `--${r}`));
  }
  const i = getComputedStyle(t).getPropertyValue(e).trim();
  if (i)
    return i;
  throw new Error(`CSS variable "${e}" was not found!`);
}
function qn(e, t) {
  const n = (e.getAttribute(`data-${t}`) || "").replace(/'/g, '"');
  return n ? JSON.parse(n) : {};
}
function Fn(e, t = !0) {
  const n = localStorage.getItem(e), i = n ? JSON.parse(n) : {};
  return {
    get(r) {
      return r ? i[r] : i;
    },
    set(r, s) {
      return s ? i[r] = s : delete i[r], t && localStorage.setItem(e, JSON.stringify(i)), i;
    }
  };
}
function Nn(e, t, n) {
  const i = t.nodeType === Node.COMMENT_NODE, r = t.nodeType === Node.ELEMENT_NODE;
  if (t = i || r ? t : document.querySelector(t), i && (n = "after"), !t)
    throw new Error(`Not a valid teleport reference: '${t}'`);
  if (typeof t[n] != "function")
    throw new Error(`Not a valid teleport method: '${n}'`);
  let s = null;
  return i || (s = document.createComment("teleported #" + e.id), e.before(s)), t[n](e), i && t.remove(), s;
}
function Wn(e, t, n, i = "--transition-duration") {
  return new Promise((r) => {
    if (typeof i == "string") {
      const s = Ge(i, e), a = !!s.includes("ms");
      i = parseFloat(s) * (a ? 1 : 1e3);
    }
    e.classList.remove(t.finish), e.classList.add(n.start), setTimeout(() => {
      e.classList.add(n.finish), e.classList.remove(n.start), r(e);
    }, i);
  });
}
function _n(e, t) {
  t && document.querySelectorAll(t).forEach((n) => {
    e ? n.style.overflow = "hidden" : n.style.removeProperty("overflow");
  });
}
function Bn(e, t) {
  t && document.querySelectorAll(t).forEach((n) => {
    e ? (n.inert = !0, n.setAttribute("aria-hidden", !0)) : (n.inert = null, n.removeAttribute("aria-hidden"));
  });
}
function Rn(e, t) {
  Bn(!!e, t.selectorInert), _n(!!e, t.selectorOverflow);
}
const zr = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  Breakpoint: In,
  Collection: An,
  FocusTrap: Dn,
  cssVar: Ge,
  getConfig: qn,
  getPrefix: Ke,
  localStore: Fn,
  teleport: Nn,
  transition: Wn,
  updateGlobalState: Rn
}, Symbol.toStringTag, { value: "Module" }));
var Qe = (e, t, n) => {
  if (!t.has(e))
    throw TypeError("Cannot " + n);
}, Wt = (e, t, n) => (Qe(e, t, "read from private field"), n ? n.call(e) : t.get(e)), Ae = (e, t, n) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, n);
}, Pe = (e, t, n, i) => (Qe(e, t, "write to private field"), i ? i.call(e, n) : t.set(e, n), n), Ze = (e, t, n) => {
  if (!t.has(e))
    throw TypeError("Cannot " + n);
}, q = (e, t, n) => (Ze(e, t, "read from private field"), n ? n.call(e) : t.get(e)), Vt = (e, t, n) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, n);
}, it = (e, t, n, i) => (Ze(e, t, "write to private field"), i ? i.call(e, n) : t.set(e, n), n), H;
let Vn = class {
  constructor(t, n) {
    Vt(this, H, void 0), this.value = t, it(this, H, n), this.mql = null;
  }
  get handler() {
    return q(this, H);
  }
  // Unmount existing handler before setting a new one.
  set handler(t) {
    this.mql && this.mql.removeEventListener("change", q(this, H)), it(this, H, t);
  }
  mount(t, n) {
    return t && (this.value = t), n && it(this, H, n), this.value ? (this.mql = window.matchMedia(`(min-width: ${this.value})`), this.mql.addEventListener("change", q(this, H)), q(this, H).call(this, this.mql), this) : this;
  }
  unmount() {
    return this.mql ? (this.mql.removeEventListener("change", q(this, H)), this.value = null, it(this, H, null), this.mql = null, this) : this;
  }
};
H = /* @__PURE__ */ new WeakMap();
let Hn = class {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const n = this.collection.findIndex((i) => i === t);
    if (n >= 0) {
      const i = this.collection[n];
      Object.getOwnPropertyNames(i).forEach((r) => {
        delete i[r];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, n = "id") {
    return this.collection.find((i) => i[n] === t);
  }
};
const g = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, Jn = [
  `a[href]${g.inert}${g.negTabIndex}`,
  `area[href]${g.inert}${g.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${g.inert}${g.negTabIndex}${g.disabled}`,
  `input[type="radio"]${g.inert}${g.negTabIndex}${g.disabled}`,
  `select${g.inert}${g.negTabIndex}${g.disabled}`,
  `textarea${g.inert}${g.negTabIndex}${g.disabled}`,
  `button${g.inert}${g.negTabIndex}${g.disabled}`,
  `details${g.inert} > summary:first-of-type${g.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${g.inert}${g.negTabIndex}`,
  `audio[controls]${g.inert}${g.negTabIndex}`,
  `video[controls]${g.inert}${g.negTabIndex}`,
  `[contenteditable]${g.inert}${g.negTabIndex}`,
  `[tabindex]${g.inert}${g.negTabIndex}`
];
var $t, ct, dt;
let zn = class {
  constructor(t = null, n = "[data-focus]") {
    Vt(this, $t, void 0), Vt(this, ct, void 0), Vt(this, dt, void 0), this.el = t, this.selectorFocus = n, it(this, ct, Kn.bind(this)), it(this, dt, Gn.bind(this));
  }
  get focusable() {
    return q(this, $t);
  }
  set focusable(t) {
    it(this, $t, t), q(this, $t).length ? (document.removeEventListener("keydown", q(this, dt)), document.addEventListener("keydown", q(this, ct))) : (document.removeEventListener("keydown", q(this, ct)), document.addEventListener("keydown", q(this, dt)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(t, n) {
    t && (this.el = t), n && (this.selectorFocus = n), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", q(this, ct)), document.removeEventListener("keydown", q(this, dt));
  }
  focus(t = this.el, n = this.selectorFocus) {
    (t.querySelector(n) || t).focus();
  }
  getFocusable(t = this.el) {
    const n = [], i = document.activeElement, r = t.scrollTop;
    return t.querySelectorAll(Jn.join(",")).forEach((s) => {
      s.focus(), document.activeElement === s && n.push(s);
    }), t.scrollTop = r, i.focus(), n;
  }
};
$t = /* @__PURE__ */ new WeakMap(), ct = /* @__PURE__ */ new WeakMap(), dt = /* @__PURE__ */ new WeakMap();
function Kn(e) {
  (e.key === "Tab" || e.keyCode === 9) && (e.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (e.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (e.preventDefault(), this.focusableFirst.focus()));
}
function Gn(e) {
  (e.key === "Tab" || e.keyCode === 9) && e.preventDefault();
}
function Xe() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-prefix").trim();
}
function Qn(e, t = document.body, n = !0) {
  if (n) {
    const r = Xe();
    r && !e.includes(`--${r}`) && (e = e.replace("--", `--${r}`));
  }
  const i = getComputedStyle(t).getPropertyValue(e).trim();
  if (i)
    return i;
  throw new Error(`CSS variable "${e}" was not found!`);
}
function Zn(e, t) {
  const n = (e.getAttribute(`data-${t}`) || "").replace(/'/g, '"');
  return n ? JSON.parse(n) : {};
}
function Xn(e, t = !0) {
  const n = localStorage.getItem(e), i = n ? JSON.parse(n) : {};
  return {
    get(r) {
      return r ? i[r] : i;
    },
    set(r, s) {
      return s ? i[r] = s : delete i[r], t && localStorage.setItem(e, JSON.stringify(i)), i;
    }
  };
}
function Ye(e, t, n, i = "--transition-duration") {
  return new Promise((r) => {
    if (typeof i == "string") {
      const s = Qn(i, e), a = !!s.includes("ms");
      i = parseFloat(s) * (a ? 1 : 1e3);
    }
    e.classList.remove(t.finish), e.classList.add(n.start), setTimeout(() => {
      e.classList.add(n.finish), e.classList.remove(n.start), r(e);
    }, i);
  });
}
function Yn(e, t) {
  t && document.querySelectorAll(t).forEach((n) => {
    e ? n.style.overflow = "hidden" : n.style.removeProperty("overflow");
  });
}
function Un(e, t) {
  t && document.querySelectorAll(t).forEach((n) => {
    e ? (n.inert = !0, n.setAttribute("aria-hidden", !0)) : (n.inert = null, n.removeAttribute("aria-hidden"));
  });
}
function ae(e, t) {
  Un(!!e, t.selectorInert), Yn(!!e, t.selectorOverflow);
}
const ti = {
  autoInit: !1,
  // Data attributes
  dataOpen: "drawer-open",
  dataClose: "drawer-close",
  dataToggle: "drawer-toggle",
  dataBreakpoint: "drawer-breakpoint",
  dataConfig: "drawer-config",
  // Selectors
  selectorDrawer: ".drawer",
  selectorDialog: ".drawer__dialog",
  selectorScreen: ".drawer",
  selectorFocus: "[data-focus]",
  selectorInert: null,
  selectorOverflow: "body",
  // State classes
  stateOpened: "is-opened",
  stateOpening: "is-opening",
  stateClosing: "is-closing",
  stateClosed: "is-closed",
  // Classes
  classModal: "drawer_modal",
  // Feature toggles
  breakpoints: null,
  customEventPrefix: "drawer:",
  eventListeners: !0,
  store: !0,
  storeKey: "VB:DrawerState",
  setTabindex: !0,
  transition: !0,
  transitionDuration: "--vb-drawer-transition-duration"
};
async function ei(e) {
  const t = e.target.closest(`
    [data-${this.settings.dataOpen}],
    [data-${this.settings.dataToggle}],
    [data-${this.settings.dataClose}]
  `);
  if (t) {
    e.preventDefault(), t.matches(`[data-${this.settings.dataToggle}]`) && t.getAttribute(`data-${this.settings.dataToggle}`).trim().split(" ").forEach((n) => {
      const i = this.get(n);
      return i.trigger = t, i.toggle();
    }), t.matches(`[data-${this.settings.dataOpen}]`) && t.getAttribute(`data-${this.settings.dataOpen}`).trim().split(" ").forEach((n) => {
      const i = this.get(n);
      return i.trigger = t, i.open();
    }), t.matches(`[data-${this.settings.dataClose}]`) && t.getAttribute(`data-${this.settings.dataClose}`).trim().split(" ").forEach((n) => {
      if (n) {
        const i = this.get(n);
        return i.trigger = t, i.close();
      } else {
        const i = e.target.closest(this.settings.selectorDrawer);
        if (i)
          return this.close(i);
      }
    });
    return;
  }
  if (this.activeModal && e.target.matches(this.settings.selectorScreen))
    return this.close(this.activeModal.id);
}
function ni(e) {
  if (e.key === "Escape" && this.activeModal)
    return this.close(this.activeModal);
}
async function ee(e, t = !0) {
  const n = this.collection.findIndex((i) => i.id === e.id);
  if (n >= 0) {
    const i = this.collection[n];
    t && i.state === "opened" && await i.close(!1), this.store.set(i.id), i.unmountBreakpoint(), Object.getOwnPropertyNames(i).forEach((r) => {
      delete i[r];
    }), this.collection.splice(n, 1);
  }
  return this.collection;
}
function ii(e) {
  e.store === "opened" ? e.open(!1, !1) : e.store === "closed" ? e.close(!1, !1) : e.store === "indeterminate" ? e.state = "indeterminate" : e.el.classList.contains(e.getSetting("stateOpened")) ? e.open(!1, !1) : e.el.classList.contains(e.getSetting("stateClosed")) ? e.close(!1, !1) : e.state = "indeterminate";
}
async function ri(e) {
  e.store === "opened" ? await e.open(!1, !1) : e.store === "closed" ? await e.close(!1, !1) : e.store === "indeterminate" ? e.state != "indeterminate" && (e.state = "indeterminate") : (e.state != e.inlineState && (e.state = e.inlineState), e.inlineState === "opened" ? await e.open(!1, !1) : e.inlineState === "closed" && await e.close(!1, !1));
}
function si(e) {
  const t = Xe(), n = e.getAttribute(`data-${this.settings.dataBreakpoint}`);
  return this.settings.breakpoints && this.settings.breakpoints[n] ? this.settings.breakpoints[n] : getComputedStyle(document.body).getPropertyValue(`--${t}breakpoint-${n}`).trim() ? getComputedStyle(document.body).getPropertyValue(`--${t}breakpoint-${n}`).trim() : n;
}
function le(e) {
  const t = typeof e == "string" ? this.get(e) : this.get(e.id);
  if (t)
    return t;
  throw new Error(`Drawer not found in collection with id of "${e.id || e}".`);
}
function Ue(e) {
  e.state === "opened" ? e.mode === "modal" ? this.focusTrap.mount(e.dialog, this.settings.selectorFocus) : this.focusTrap.focus(e.dialog, this.settings.selectorFocus) : (e.trigger && (e.trigger.focus(), e.trigger = null), this.focusTrap.unmount());
}
async function ce(e, t, n = !0) {
  const i = le.call(this, e), r = { ...this.settings, ...i.settings };
  return t !== void 0 && (r.transition = t), (i.state === "closed" || i.state === "indeterminate") && (i.state = "opening", r.transition ? await Ye(i.el, {
    start: r.stateClosing,
    finish: r.stateClosed
  }, {
    start: r.stateOpening,
    finish: r.stateOpened
  }, r.transitionDuration) : (i.el.classList.add(r.stateOpened), i.el.classList.remove(r.stateClosed)), i.state = "opened", i.mode === "modal" && ae(!0, r), n && Ue.call(this, i), i.el.dispatchEvent(new CustomEvent(r.customEventPrefix + "opened", {
    detail: this,
    bubbles: !0
  }))), i;
}
async function zt(e, t, n = !0) {
  const i = le.call(this, e), r = { ...this.settings, ...i.settings };
  return t !== void 0 && (r.transition = t), (i.state === "opened" || i.state === "indeterminate") && (i.state = "closing", document.activeElement.blur(), r.transition ? await Ye(i.el, {
    start: r.stateOpening,
    finish: r.stateOpened
  }, {
    start: r.stateClosing,
    finish: r.stateClosed
  }, r.transitionDuration) : (i.el.classList.add(r.stateClosed), i.el.classList.remove(r.stateOpened)), i.state = "closed", i.mode === "modal" && ae(!1, r), n && Ue.call(this, i), i.el.dispatchEvent(new CustomEvent(r.customEventPrefix + "closed", {
    detail: this,
    bubbles: !0
  }))), i;
}
async function tn(e, t, n) {
  const i = le.call(this, e);
  return i.state === "closed" ? ce.call(this, i, t, n) : zt.call(this, i, t, n);
}
function oi(e) {
  switch (e.mode) {
    case "inline":
      return ai.call(this, e);
    case "modal":
      return li.call(this, e);
    default:
      throw new Error(`"${e.mode}" is not a valid drawer mode.`);
  }
}
async function ai(e) {
  return e.el.classList.remove(e.getSetting("classModal")), e.dialog.removeAttribute("aria-modal"), ae(!1, { ...this.settings, ...e.settings }), this.focusTrap.unmount(), await ri(e), e.el.dispatchEvent(new CustomEvent(e.getSetting("customEventPrefix") + "switchMode", {
    detail: this,
    bubbles: !0
  })), e;
}
async function li(e) {
  return e.el.classList.add(e.getSetting("classModal")), e.dialog.setAttribute("aria-modal", "true"), await zt.call(this, e, !1, !1), e.el.dispatchEvent(new CustomEvent(e.getSetting("customEventPrefix") + "switchMode", {
    detail: this,
    bubbles: !0
  })), e;
}
async function ci(e, t = {}) {
  await ee.call(this, e, !1);
  const n = this, i = new Vn();
  let r, s = "indeterminate";
  const a = {
    id: e.id,
    el: e,
    dialog: null,
    trigger: null,
    settings: { ...Zn(e, this.settings.dataConfig), ...t },
    inlineState: "indeterminate",
    get breakpoint() {
      return si.call(n, e);
    },
    get store() {
      return n.store.get(this.id);
    },
    get mode() {
      return r;
    },
    set mode(o) {
      r = o, oi.call(n, this);
    },
    get state() {
      return s;
    },
    set state(o) {
      s = o, this.mode === "inline" && o != "opening" && o != "closing" && (this.inlineState = o, this.getSetting("store") && n.store.set(this.id, o)), o === "indeterminate" && (this.el.classList.remove(this.getSetting("stateOpened")), this.el.classList.remove(this.getSetting("stateOpening")), this.el.classList.remove(this.getSetting("stateClosed")), this.el.classList.remove(this.getSetting("stateClosing")));
    },
    open(o, l) {
      return ce.call(n, this, o, l);
    },
    close(o, l) {
      return zt.call(n, this, o, l);
    },
    toggle(o, l) {
      return tn.call(n, this, o, l);
    },
    deregister() {
      return ee.call(n, this);
    },
    mountBreakpoint() {
      const o = this.breakpoint, l = this.handleBreakpoint.bind(this);
      return i.mount(o, l), this;
    },
    unmountBreakpoint() {
      return i.unmount(), this;
    },
    handleBreakpoint(o) {
      const l = o.matches ? "inline" : "modal";
      return this.mode != l && (this.mode = l), this;
    },
    getSetting(o) {
      return o in this.settings ? this.settings[o] : n.settings[o];
    }
  };
  this.collection.push(a);
  const c = e.querySelector(a.getSetting("selectorDialog"));
  return a.dialog = c || e, a.getSetting("setTabindex") && a.dialog.setAttribute("tabindex", "-1"), await ii(a), a.inlineState = a.state, a.mode = e.classList.contains(a.getSetting("classModal")) ? "modal" : "inline", a.breakpoint && a.mountBreakpoint(), a;
}
var Et, xt;
let Zr = class extends Hn {
  constructor(t) {
    super(), Ae(this, Et, void 0), Ae(this, xt, void 0), this.defaults = ti, this.settings = { ...this.defaults, ...t }, this.focusTrap = new zn(), this.store = Xn(this.settings.storeKey, this.settings.store), Pe(this, Et, ei.bind(this)), Pe(this, xt, ni.bind(this)), this.settings.autoInit && this.init();
  }
  get activeModal() {
    return this.collection.find((t) => t.state === "opened" && t.mode === "modal");
  }
  async init(t = null) {
    t && (this.settings = { ...this.settings, ...t });
    const n = document.querySelectorAll(this.settings.selectorDrawer);
    return await this.registerCollection(n), this.settings.eventListeners && this.initEventListeners(), this;
  }
  async destroy() {
    return await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
  }
  initEventListeners() {
    document.addEventListener("click", Wt(this, Et), !1), document.addEventListener("keydown", Wt(this, xt), !1);
  }
  destroyEventListeners() {
    document.removeEventListener("click", Wt(this, Et), !1), document.removeEventListener("keydown", Wt(this, xt), !1);
  }
  register(t, n = {}) {
    let i = typeof t == "string" ? document.getElementById(t) : t;
    return i ? ci.call(this, i, n) : Promise.reject(new Error(`Failed to register; drawer not found with ID of: "${t.id || t}".`));
  }
  deregister(t) {
    let n = this.get(t.id || t);
    return n ? ee.call(this, n) : Promise.reject(new Error(`Failed to deregister; drawer does not exist in collection with ID of: "${t.id || t}".`));
  }
  open(t, n, i) {
    return ce.call(this, t, n, i);
  }
  close(t, n, i) {
    return zt.call(this, t, n, i);
  }
  toggle(t, n, i) {
    return tn.call(this, t, n, i);
  }
};
Et = /* @__PURE__ */ new WeakMap(), xt = /* @__PURE__ */ new WeakMap();
var en = (e, t, n) => {
  if (!t.has(e))
    throw TypeError("Cannot " + n);
}, _t = (e, t, n) => (en(e, t, "read from private field"), n ? n.call(e) : t.get(e)), De = (e, t, n) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, n);
}, Me = (e, t, n, i) => (en(e, t, "write to private field"), i ? i.call(e, n) : t.set(e, n), n), nn = (e, t, n) => {
  if (!t.has(e))
    throw TypeError("Cannot " + n);
}, Q = (e, t, n) => (nn(e, t, "read from private field"), n ? n.call(e) : t.get(e)), Yt = (e, t, n) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, n);
}, Ut = (e, t, n, i) => (nn(e, t, "write to private field"), i ? i.call(e, n) : t.set(e, n), n);
class di {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const n = this.collection.findIndex((i) => i === t);
    if (n >= 0) {
      const i = this.collection[n];
      Object.getOwnPropertyNames(i).forEach((r) => {
        delete i[r];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, n = "id") {
    return this.collection.find((i) => i[n] === t);
  }
}
const m = {
  inert: ":not([inert]):not([inert] *)",
  negTabIndex: ':not([tabindex^="-"])',
  disabled: ":not(:disabled)"
}, ui = [
  `a[href]${m.inert}${m.negTabIndex}`,
  `area[href]${m.inert}${m.negTabIndex}`,
  `input:not([type="hidden"]):not([type="radio"])${m.inert}${m.negTabIndex}${m.disabled}`,
  `input[type="radio"]${m.inert}${m.negTabIndex}${m.disabled}`,
  `select${m.inert}${m.negTabIndex}${m.disabled}`,
  `textarea${m.inert}${m.negTabIndex}${m.disabled}`,
  `button${m.inert}${m.negTabIndex}${m.disabled}`,
  `details${m.inert} > summary:first-of-type${m.negTabIndex}`,
  // Discard until Firefox supports `:has()`
  // See: https://github.com/KittyGiraudel/focusable-selectors/issues/12
  // `details:not(:has(> summary))${not.inert}${not.negTabIndex}`,
  `iframe${m.inert}${m.negTabIndex}`,
  `audio[controls]${m.inert}${m.negTabIndex}`,
  `video[controls]${m.inert}${m.negTabIndex}`,
  `[contenteditable]${m.inert}${m.negTabIndex}`,
  `[tabindex]${m.inert}${m.negTabIndex}`
];
var Ot, ut, ht;
class hi {
  constructor(t = null, n = "[data-focus]") {
    Yt(this, Ot, void 0), Yt(this, ut, void 0), Yt(this, ht, void 0), this.el = t, this.selectorFocus = n, Ut(this, ut, fi.bind(this)), Ut(this, ht, pi.bind(this));
  }
  get focusable() {
    return Q(this, Ot);
  }
  set focusable(t) {
    Ut(this, Ot, t), Q(this, Ot).length ? (document.removeEventListener("keydown", Q(this, ht)), document.addEventListener("keydown", Q(this, ut))) : (document.removeEventListener("keydown", Q(this, ut)), document.addEventListener("keydown", Q(this, ht)));
  }
  get focusableFirst() {
    return this.focusable[0];
  }
  get focusableLast() {
    return this.focusable[this.focusable.length - 1];
  }
  mount(t, n) {
    t && (this.el = t), n && (this.selectorFocus = n), this.focusable = this.getFocusable(), this.focus();
  }
  unmount() {
    this.el = null, this.focusable = [], document.removeEventListener("keydown", Q(this, ut)), document.removeEventListener("keydown", Q(this, ht));
  }
  focus(t = this.el, n = this.selectorFocus) {
    (t.querySelector(n) || t).focus();
  }
  getFocusable(t = this.el) {
    const n = [], i = document.activeElement, r = t.scrollTop;
    return t.querySelectorAll(ui.join(",")).forEach((s) => {
      s.focus(), document.activeElement === s && n.push(s);
    }), t.scrollTop = r, i.focus(), n;
  }
}
Ot = /* @__PURE__ */ new WeakMap(), ut = /* @__PURE__ */ new WeakMap(), ht = /* @__PURE__ */ new WeakMap();
function fi(e) {
  (e.key === "Tab" || e.keyCode === 9) && (e.shiftKey ? (document.activeElement === this.focusableFirst || document.activeElement === this.el) && (e.preventDefault(), this.focusableLast.focus()) : (document.activeElement === this.focusableLast || document.activeElement === this.el) && (e.preventDefault(), this.focusableFirst.focus()));
}
function pi(e) {
  (e.key === "Tab" || e.keyCode === 9) && e.preventDefault();
}
function gi() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-prefix").trim();
}
function mi(e, t = document.body, n = !0) {
  if (n) {
    const r = gi();
    r && !e.includes(`--${r}`) && (e = e.replace("--", `--${r}`));
  }
  const i = getComputedStyle(t).getPropertyValue(e).trim();
  if (i)
    return i;
  throw new Error(`CSS variable "${e}" was not found!`);
}
function vi(e, t) {
  const n = (e.getAttribute(`data-${t}`) || "").replace(/'/g, '"');
  return n ? JSON.parse(n) : {};
}
function je(e, t, n) {
  const i = t.nodeType === Node.COMMENT_NODE, r = t.nodeType === Node.ELEMENT_NODE;
  if (t = i || r ? t : document.querySelector(t), i && (n = "after"), !t)
    throw new Error(`Not a valid teleport reference: '${t}'`);
  if (typeof t[n] != "function")
    throw new Error(`Not a valid teleport method: '${n}'`);
  let s = null;
  return i || (s = document.createComment("teleported #" + e.id), e.before(s)), t[n](e), i && t.remove(), s;
}
function rn(e, t, n, i = "--transition-duration") {
  return new Promise((r) => {
    if (typeof i == "string") {
      const s = mi(i, e), a = !!s.includes("ms");
      i = parseFloat(s) * (a ? 1 : 1e3);
    }
    e.classList.remove(t.finish), e.classList.add(n.start), setTimeout(() => {
      e.classList.add(n.finish), e.classList.remove(n.start), r(e);
    }, i);
  });
}
function bi(e, t) {
  t && document.querySelectorAll(t).forEach((n) => {
    e ? n.style.overflow = "hidden" : n.style.removeProperty("overflow");
  });
}
function yi(e, t) {
  t && document.querySelectorAll(t).forEach((n) => {
    e ? (n.inert = !0, n.setAttribute("aria-hidden", !0)) : (n.inert = null, n.removeAttribute("aria-hidden"));
  });
}
function wi(e, t) {
  yi(!!e, t.selectorInert), bi(!!e, t.selectorOverflow);
}
const $i = {
  autoInit: !1,
  // Data attributes
  dataOpen: "modal-open",
  dataClose: "modal-close",
  dataReplace: "modal-replace",
  dataConfig: "modal-config",
  // Selectors
  selectorModal: ".modal",
  selectorDialog: ".modal__dialog",
  selectorScreen: ".modal",
  selectorRequired: '[role="alertdialog"]',
  selectorFocus: "[data-focus]",
  selectorInert: null,
  selectorOverflow: "body",
  // State classes
  stateOpened: "is-opened",
  stateOpening: "is-opening",
  stateClosing: "is-closing",
  stateClosed: "is-closed",
  // Feature settings
  customEventPrefix: "modal:",
  eventListeners: !0,
  teleport: null,
  teleportMethod: "append",
  setTabindex: !0,
  transition: !0,
  transitionDuration: "--vb-modal-transition-duration"
};
async function Ei(e) {
  const t = e.target.closest(`
    [data-${this.settings.dataOpen}],
    [data-${this.settings.dataReplace}],
    [data-${this.settings.dataClose}]
  `);
  if (t) {
    if (e.preventDefault(), t.matches(`[data-${this.settings.dataOpen}]`)) {
      const n = t.getAttribute(`data-${this.settings.dataOpen}`).trim(), i = this.get(n);
      return e.target.closest(this.settings.selectorModal) || (this.trigger = t), i.open();
    }
    if (t.matches(`[data-${this.settings.dataReplace}]`)) {
      const n = t.getAttribute(`data-${this.settings.dataReplace}`).trim(), i = this.get(n);
      return e.target.closest(this.settings.selectorModal) || (this.trigger = t), i.replace();
    }
    if (t.matches(`[data-${this.settings.dataClose}]`)) {
      const n = t.getAttribute(`data-${this.settings.dataClose}`).trim();
      return n === "*" ? this.closeAll() : this.close(n);
    }
  }
  if (this.active && e.target.matches(this.settings.selectorScreen) && !this.active.required)
    return this.close(this.active.id);
}
function xi(e) {
  if (e.key === "Escape" && this.active && !this.active.dialog.matches(this.settings.selectorRequired))
    return this.close();
}
async function ne(e, t = !0) {
  const n = this.collection.findIndex((i) => i.id === e.id);
  if (n >= 0) {
    const i = this.collection[n];
    t && i.state === "opened" ? await i.close(!1) : this.stack.remove(i), i.getSetting("teleport") && i.teleportReturn(), Object.getOwnPropertyNames(i).forEach((r) => {
      delete i[r];
    }), this.collection.splice(n, 1);
  }
  return this.collection;
}
function de(e) {
  const t = typeof e == "string" ? this.get(e) : this.get(e.id);
  if (t)
    return t;
  throw new Error(`Modal not found in collection with id of "${e.id || e}".`);
}
function Kt() {
  this.active ? this.focusTrap.mount(this.active.dialog, this.settings.selectorFocus) : (this.trigger && (this.trigger.focus(), this.trigger = null), this.focusTrap.unmount());
}
async function ue(e, t, n = !0) {
  const i = de.call(this, e), r = { ...this.settings, ...i.settings };
  return t !== void 0 && (r.transition = t), this.stack.moveToTop(i), i.state === "closed" && (i.state = "opening", this.stack.add(i), r.transition ? await rn(i.el, {
    start: r.stateClosing,
    finish: r.stateClosed
  }, {
    start: r.stateOpening,
    finish: r.stateOpened
  }, r.transitionDuration) : (i.el.classList.add(r.stateOpened), i.el.classList.remove(r.stateClosed)), i.state = "opened"), n && Kt.call(this), i.el.dispatchEvent(new CustomEvent(r.customEventPrefix + "opened", {
    detail: this,
    bubbles: !0
  })), i;
}
async function he(e, t, n = !0) {
  const i = e ? de.call(this, e) : this.active;
  if (i && i.state === "opened") {
    i.state = "closing";
    const r = { ...this.settings, ...i.settings };
    t !== void 0 && (r.transition = t), document.activeElement.blur(), r.transition ? await rn(i.el, {
      start: r.stateOpening,
      finish: r.stateOpened
    }, {
      start: r.stateClosing,
      finish: r.stateClosed
    }, r.transitionDuration) : (i.el.classList.add(r.stateClosed), i.el.classList.remove(r.stateOpened)), this.stack.remove(i), i.state = "closed", n && Kt.call(this), i.el.dispatchEvent(new CustomEvent(r.customEventPrefix + "closed", {
      detail: this,
      bubbles: !0
    }));
  }
  return i;
}
async function ie(e, t) {
  const n = [];
  return await Promise.all(this.stack.value.map(async (i) => {
    e && e === i.id ? Promise.resolve() : n.push(await he.call(this, i, t, !1)), i.trigger = null;
  })), n;
}
async function sn(e, t, n = !0) {
  const i = de.call(this, e);
  let r, s;
  return i.state === "opened" ? (r = i, s = await ie.call(this, i.id, t)) : (s = ie.call(this, !1, t), r = ue.call(this, i, t, !1), await Promise.all([r, s])), n && Kt.call(this), { opened: r, closed: s };
}
async function Oi(e, t = {}) {
  await ne.call(this, e, !1);
  const n = this, i = {
    id: e.id,
    state: "closed",
    el: e,
    dialog: null,
    get required() {
      return this.dialog.matches(this.getSetting("selectorRequired"));
    },
    returnRef: null,
    settings: { ...vi(e, this.settings.dataConfig), ...t },
    open(s, a) {
      return ue.call(n, this, s, a);
    },
    close(s, a) {
      return he.call(n, this, s, a);
    },
    replace(s, a) {
      return sn.call(n, this, s, a);
    },
    deregister() {
      return ne.call(n, this);
    },
    teleport(s = this.getSetting("teleport"), a = this.getSetting("teleportMethod")) {
      return this.returnRef ? (console.error("Element has already been teleported:", this.el), !1) : (this.returnRef = je(this.el, s, a), this.el);
    },
    teleportReturn() {
      return this.returnRef ? (this.returnRef = je(this.el, this.returnRef), this.el) : (console.error("No return reference found:", this.el), !1);
    },
    getSetting(s) {
      return s in this.settings ? this.settings[s] : n.settings[s];
    }
  }, r = e.querySelector(i.getSetting("selectorDialog"));
  return i.dialog = r || e, i.dialog.setAttribute("aria-modal", "true"), i.dialog.hasAttribute("role") || i.dialog.setAttribute("role", "dialog"), i.getSetting("setTabindex") && i.dialog.setAttribute("tabindex", "-1"), i.getSetting("teleport") && i.teleport(), this.collection.push(i), i.el.classList.contains(this.settings.stateOpened) ? await i.open(!1) : (i.el.classList.remove(this.settings.stateOpening), i.el.classList.remove(this.settings.stateClosing), i.el.classList.add(this.settings.stateClosed)), i;
}
function Li(e) {
  const t = [];
  return {
    get value() {
      return [...t];
    },
    get top() {
      return t[t.length - 1];
    },
    updateIndex() {
      t.forEach((n, i) => {
        n.el.style.zIndex = null;
        const r = getComputedStyle(n.el)["z-index"];
        n.el.style.zIndex = parseInt(r) + i + 1;
      });
    },
    updateGlobalState() {
      wi(this.top, e), this.updateIndex();
    },
    add(n) {
      n.el.style.zIndex = null;
      const i = getComputedStyle(n.el)["z-index"];
      n.el.style.zIndex = parseInt(i) + t.length + 1, t.push(n), this.updateGlobalState();
    },
    remove(n) {
      const i = t.findIndex((r) => r.id === n.id);
      i >= 0 && (n.el.style.zIndex = null, t.splice(i, 1), this.updateGlobalState());
    },
    moveToTop(n) {
      const i = t.findIndex((r) => r.id === n.id);
      i >= 0 && (t.splice(i, 1), this.add(n));
    }
  };
}
var Lt, kt;
let Yr = class extends di {
  constructor(t) {
    super(), De(this, Lt, void 0), De(this, kt, void 0), this.defaults = $i, this.settings = { ...this.defaults, ...t }, this.trigger = null, this.focusTrap = new hi(), this.stack = Li(this.settings), Me(this, Lt, Ei.bind(this)), Me(this, kt, xi.bind(this)), this.settings.autoInit && this.init();
  }
  get active() {
    return this.stack.top;
  }
  async init(t) {
    t && (this.settings = { ...this.settings, ...t });
    const n = document.querySelectorAll(this.settings.selectorModal);
    return await this.registerCollection(n), this.settings.eventListeners && this.initEventListeners(), this;
  }
  async destroy() {
    return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(), this;
  }
  initEventListeners() {
    document.addEventListener("click", _t(this, Lt), !1), document.addEventListener("keydown", _t(this, kt), !1);
  }
  destroyEventListeners() {
    document.removeEventListener("click", _t(this, Lt), !1), document.removeEventListener("keydown", _t(this, kt), !1);
  }
  register(t, n = {}) {
    let i = typeof t == "string" ? document.getElementById(t) : t;
    return i ? Oi.call(this, i, n) : Promise.reject(new Error(`Failed to register; modal not found with ID of: "${t.id || t}".`));
  }
  deregister(t) {
    let n = this.get(t.id || t);
    return n ? ne.call(this, n) : Promise.reject(new Error(`Failed to deregister; modal does not exist in collection with ID of: "${t.id || t}".`));
  }
  open(t, n, i) {
    return ue.call(this, t, n, i);
  }
  close(t, n, i) {
    return he.call(this, t, n, i);
  }
  replace(t, n, i) {
    return sn.call(this, t, n, i);
  }
  async closeAll(t = !1, n, i = !0) {
    const r = await ie.call(this, t, n);
    return i && Kt.call(this), r;
  }
};
Lt = /* @__PURE__ */ new WeakMap(), kt = /* @__PURE__ */ new WeakMap();
var on = (e, t, n) => {
  if (!t.has(e))
    throw TypeError("Cannot " + n);
}, qe = (e, t, n) => (on(e, t, "read from private field"), n ? n.call(e) : t.get(e)), ki = (e, t, n) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, n);
}, Ti = (e, t, n, i) => (on(e, t, "write to private field"), i ? i.call(e, n) : t.set(e, n), n);
class Si {
  constructor() {
    this.collection = [];
  }
  async register(t) {
    return await this.deregister(t), this.collection.push(t), this.collection;
  }
  async deregister(t) {
    const n = this.collection.findIndex((i) => i === t);
    if (n >= 0) {
      const i = this.collection[n];
      Object.getOwnPropertyNames(i).forEach((r) => {
        delete i[r];
      }), this.collection.splice(n, 1);
    }
    return this.collection;
  }
  async registerCollection(t) {
    return await Promise.all(Array.from(t, (n) => {
      this.register(n);
    })), this.collection;
  }
  async deregisterCollection() {
    for (; this.collection.length > 0; )
      await this.deregister(this.collection[0]);
    return this.collection;
  }
  get(t, n = "id") {
    return this.collection.find((i) => i[n] === t);
  }
}
function Ci() {
  return getComputedStyle(document.body).getPropertyValue("--vrembem-prefix").trim();
}
const Ii = {
  autoInit: !1,
  // Selectors
  selectorPopover: ".popover",
  selectorArrow: ".popover__arrow",
  // State classes
  stateActive: "is-active",
  // Feature settings
  eventListeners: !0,
  eventType: "click",
  placement: "bottom"
};
function an(e, t) {
  const n = getComputedStyle(e), i = {
    placement: t.placement,
    event: t.eventType,
    offset: 0,
    "overflow-padding": 0,
    "flip-padding": 0,
    "arrow-element": t.selectorArrow,
    "arrow-padding": 0
  };
  for (const r in i) {
    const s = Ci(), a = n.getPropertyValue(`--${s}popover-${r}`).trim();
    a && (i[r] = a);
  }
  return i;
}
function te(e) {
  let t;
  const n = typeof e == "string" ? e.trim().split(" ") : [e];
  switch (n.forEach(function(i, r) {
    n[r] = parseInt(i, 10);
  }), n.length) {
    case 1:
      t = n[0];
      break;
    case 2:
      t = {
        top: n[0],
        right: n[1],
        bottom: n[0],
        left: n[1]
      };
      break;
    case 3:
      t = {
        top: n[0],
        right: n[1],
        bottom: n[2],
        left: n[1]
      };
      break;
    case 4:
      t = {
        top: n[0],
        right: n[1],
        bottom: n[2],
        left: n[3]
      };
      break;
    default:
      t = !1;
      break;
  }
  return t;
}
function Ai(e) {
  return [{
    name: "offset",
    options: {
      offset: [0, parseInt(e.offset, 10)]
    }
  }, {
    name: "preventOverflow",
    options: {
      padding: te(e["overflow-padding"])
    }
  }, {
    name: "flip",
    options: {
      padding: te(e["flip-padding"])
    }
  }, {
    name: "arrow",
    options: {
      element: e["arrow-element"],
      padding: te(e["arrow-padding"])
    }
  }];
}
function ln(e) {
  const t = typeof e == "string" ? this.get(e) : this.get(e.id);
  if (t)
    return t;
  throw new Error(`Popover not found in collection with id of "${e}".`);
}
function Pi(e) {
  return typeof e == "string" ? e : typeof e.hasAttribute == "function" ? e.closest(this.settings.selectorPopover) ? (e = e.closest(this.settings.selectorPopover), e.id) : e.hasAttribute("aria-controls") ? e.getAttribute("aria-controls") : e.hasAttribute("aria-describedby") ? e.getAttribute("aria-describedby") : !1 : !1;
}
function Di(e) {
  const t = Pi.call(this, e);
  if (t) {
    const n = document.querySelector(`#${t}`), i = document.querySelector(`[aria-controls="${t}"]`) || document.querySelector(`[aria-describedby="${t}"]`);
    return !i && !n ? { error: new Error(`No popover elements found using the ID: "${t}".`) } : i ? n ? { popover: n, trigger: i } : { error: new Error("No popover associated with the provided popover trigger.") } : { error: new Error("No popover trigger associated with the provided popover.") };
  } else
    return { error: new Error("Could not resolve the popover ID.") };
}
async function fe(e) {
  const t = e ? ln.call(this, e) : await cn.call(this);
  return t && t.state === "opened" && (t.el.classList.remove(this.settings.stateActive), t.trigger.hasAttribute("aria-controls") && t.trigger.setAttribute("aria-expanded", "false"), t.popper.setOptions({
    modifiers: [{ name: "eventListeners", enabled: !1 }]
  }), t.state = "closed", t.trigger === this.trigger && (this.trigger = null)), t;
}
async function cn() {
  const e = [];
  return await Promise.all(this.collection.map(async (t) => {
    t.state === "opened" && e.push(await fe.call(this, t));
  })), e;
}
function dn(e) {
  e.state == "opened" && setTimeout(() => {
    const t = e.el.closest(":hover") === e.el || e.trigger.closest(":hover") === e.trigger, n = document.activeElement.closest(
      `#${e.id}, [aria-controls="${e.id}"], [aria-describedby="${e.id}"]`
    );
    return !t && !n && e.close(), e;
  }, 1);
}
function Mi(e) {
  e.state === "opened" ? e.close() : (this.trigger = e.trigger, e.open(), un.call(this, e));
}
function ji(e) {
  switch (e.key) {
    case "Escape":
      this.trigger && this.trigger.focus(), cn.call(this);
      return;
    case "Tab":
      this.collection.forEach((t) => {
        dn.call(this, t);
      });
      return;
    default:
      return;
  }
}
function un(e) {
  const t = this;
  document.addEventListener("click", function n(i) {
    i.target.closest(
      `#${e.id}, [aria-controls="${e.id}"], [aria-describedby="${e.id}"]`
    ) ? e.el && !e.el.classList.contains(t.settings.stateActive) && this.removeEventListener("click", n) : (e.el && e.el.classList.contains(t.settings.stateActive) && e.close(), this.removeEventListener("click", n));
  });
}
var P = "top", W = "bottom", _ = "right", D = "left", pe = "auto", Pt = [P, W, _, D], ft = "start", It = "end", qi = "clippingParents", hn = "viewport", yt = "popper", Fi = "reference", Fe = /* @__PURE__ */ Pt.reduce(function(e, t) {
  return e.concat([t + "-" + ft, t + "-" + It]);
}, []), fn = /* @__PURE__ */ [].concat(Pt, [pe]).reduce(function(e, t) {
  return e.concat([t, t + "-" + ft, t + "-" + It]);
}, []), Ni = "beforeRead", Wi = "read", _i = "afterRead", Bi = "beforeMain", Ri = "main", Vi = "afterMain", Hi = "beforeWrite", Ji = "write", zi = "afterWrite", Ki = [Ni, Wi, _i, Bi, Ri, Vi, Hi, Ji, zi];
function z(e) {
  return e ? (e.nodeName || "").toLowerCase() : null;
}
function F(e) {
  if (e == null)
    return window;
  if (e.toString() !== "[object Window]") {
    var t = e.ownerDocument;
    return t && t.defaultView || window;
  }
  return e;
}
function st(e) {
  var t = F(e).Element;
  return e instanceof t || e instanceof Element;
}
function N(e) {
  var t = F(e).HTMLElement;
  return e instanceof t || e instanceof HTMLElement;
}
function ge(e) {
  if (typeof ShadowRoot > "u")
    return !1;
  var t = F(e).ShadowRoot;
  return e instanceof t || e instanceof ShadowRoot;
}
function Gi(e) {
  var t = e.state;
  Object.keys(t.elements).forEach(function(n) {
    var i = t.styles[n] || {}, r = t.attributes[n] || {}, s = t.elements[n];
    !N(s) || !z(s) || (Object.assign(s.style, i), Object.keys(r).forEach(function(a) {
      var c = r[a];
      c === !1 ? s.removeAttribute(a) : s.setAttribute(a, c === !0 ? "" : c);
    }));
  });
}
function Qi(e) {
  var t = e.state, n = {
    popper: {
      position: t.options.strategy,
      left: "0",
      top: "0",
      margin: "0"
    },
    arrow: {
      position: "absolute"
    },
    reference: {}
  };
  return Object.assign(t.elements.popper.style, n.popper), t.styles = n, t.elements.arrow && Object.assign(t.elements.arrow.style, n.arrow), function() {
    Object.keys(t.elements).forEach(function(i) {
      var r = t.elements[i], s = t.attributes[i] || {}, a = Object.keys(t.styles.hasOwnProperty(i) ? t.styles[i] : n[i]), c = a.reduce(function(o, l) {
        return o[l] = "", o;
      }, {});
      !N(r) || !z(r) || (Object.assign(r.style, c), Object.keys(s).forEach(function(o) {
        r.removeAttribute(o);
      }));
    });
  };
}
const Zi = {
  name: "applyStyles",
  enabled: !0,
  phase: "write",
  fn: Gi,
  effect: Qi,
  requires: ["computeStyles"]
};
function J(e) {
  return e.split("-")[0];
}
var rt = Math.max, Jt = Math.min, pt = Math.round;
function re() {
  var e = navigator.userAgentData;
  return e != null && e.brands && Array.isArray(e.brands) ? e.brands.map(function(t) {
    return t.brand + "/" + t.version;
  }).join(" ") : navigator.userAgent;
}
function pn() {
  return !/^((?!chrome|android).)*safari/i.test(re());
}
function gt(e, t, n) {
  t === void 0 && (t = !1), n === void 0 && (n = !1);
  var i = e.getBoundingClientRect(), r = 1, s = 1;
  t && N(e) && (r = e.offsetWidth > 0 && pt(i.width) / e.offsetWidth || 1, s = e.offsetHeight > 0 && pt(i.height) / e.offsetHeight || 1);
  var a = st(e) ? F(e) : window, c = a.visualViewport, o = !pn() && n, l = (i.left + (o && c ? c.offsetLeft : 0)) / r, d = (i.top + (o && c ? c.offsetTop : 0)) / s, b = i.width / r, v = i.height / s;
  return {
    width: b,
    height: v,
    top: d,
    right: l + b,
    bottom: d + v,
    left: l,
    x: l,
    y: d
  };
}
function me(e) {
  var t = gt(e), n = e.offsetWidth, i = e.offsetHeight;
  return Math.abs(t.width - n) <= 1 && (n = t.width), Math.abs(t.height - i) <= 1 && (i = t.height), {
    x: e.offsetLeft,
    y: e.offsetTop,
    width: n,
    height: i
  };
}
function gn(e, t) {
  var n = t.getRootNode && t.getRootNode();
  if (e.contains(t))
    return !0;
  if (n && ge(n)) {
    var i = t;
    do {
      if (i && e.isSameNode(i))
        return !0;
      i = i.parentNode || i.host;
    } while (i);
  }
  return !1;
}
function G(e) {
  return F(e).getComputedStyle(e);
}
function Xi(e) {
  return ["table", "td", "th"].indexOf(z(e)) >= 0;
}
function Z(e) {
  return ((st(e) ? e.ownerDocument : (
    // $FlowFixMe[prop-missing]
    e.document
  )) || window.document).documentElement;
}
function Gt(e) {
  return z(e) === "html" ? e : (
    // this is a quicker (but less type safe) way to save quite some bytes from the bundle
    // $FlowFixMe[incompatible-return]
    // $FlowFixMe[prop-missing]
    e.assignedSlot || // step into the shadow DOM of the parent of a slotted node
    e.parentNode || // DOM Element detected
    (ge(e) ? e.host : null) || // ShadowRoot detected
    // $FlowFixMe[incompatible-call]: HTMLElement is a Node
    Z(e)
  );
}
function Ne(e) {
  return !N(e) || // https://github.com/popperjs/popper-core/issues/837
  G(e).position === "fixed" ? null : e.offsetParent;
}
function Yi(e) {
  var t = /firefox/i.test(re()), n = /Trident/i.test(re());
  if (n && N(e)) {
    var i = G(e);
    if (i.position === "fixed")
      return null;
  }
  var r = Gt(e);
  for (ge(r) && (r = r.host); N(r) && ["html", "body"].indexOf(z(r)) < 0; ) {
    var s = G(r);
    if (s.transform !== "none" || s.perspective !== "none" || s.contain === "paint" || ["transform", "perspective"].indexOf(s.willChange) !== -1 || t && s.willChange === "filter" || t && s.filter && s.filter !== "none")
      return r;
    r = r.parentNode;
  }
  return null;
}
function Dt(e) {
  for (var t = F(e), n = Ne(e); n && Xi(n) && G(n).position === "static"; )
    n = Ne(n);
  return n && (z(n) === "html" || z(n) === "body" && G(n).position === "static") ? t : n || Yi(e) || t;
}
function ve(e) {
  return ["top", "bottom"].indexOf(e) >= 0 ? "x" : "y";
}
function St(e, t, n) {
  return rt(e, Jt(t, n));
}
function Ui(e, t, n) {
  var i = St(e, t, n);
  return i > n ? n : i;
}
function mn() {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  };
}
function vn(e) {
  return Object.assign({}, mn(), e);
}
function bn(e, t) {
  return t.reduce(function(n, i) {
    return n[i] = e, n;
  }, {});
}
var tr = function(e, t) {
  return e = typeof e == "function" ? e(Object.assign({}, t.rects, {
    placement: t.placement
  })) : e, vn(typeof e != "number" ? e : bn(e, Pt));
};
function er(e) {
  var t, n = e.state, i = e.name, r = e.options, s = n.elements.arrow, a = n.modifiersData.popperOffsets, c = J(n.placement), o = ve(c), l = [D, _].indexOf(c) >= 0, d = l ? "height" : "width";
  if (!(!s || !a)) {
    var b = tr(r.padding, n), v = me(s), h = o === "y" ? P : D, $ = o === "y" ? W : _, u = n.rects.reference[d] + n.rects.reference[o] - a[o] - n.rects.popper[d], w = a[o] - n.rects.reference[o], E = Dt(s), O = E ? o === "y" ? E.clientHeight || 0 : E.clientWidth || 0 : 0, L = u / 2 - w / 2, f = b[h], y = O - v[d] - b[$], x = O / 2 - v[d] / 2 + L, k = St(f, x, y), T = o;
    n.modifiersData[i] = (t = {}, t[T] = k, t.centerOffset = k - x, t);
  }
}
function nr(e) {
  var t = e.state, n = e.options, i = n.element, r = i === void 0 ? "[data-popper-arrow]" : i;
  r != null && (typeof r == "string" && (r = t.elements.popper.querySelector(r), !r) || gn(t.elements.popper, r) && (t.elements.arrow = r));
}
const ir = {
  name: "arrow",
  enabled: !0,
  phase: "main",
  fn: er,
  effect: nr,
  requires: ["popperOffsets"],
  requiresIfExists: ["preventOverflow"]
};
function mt(e) {
  return e.split("-")[1];
}
var rr = {
  top: "auto",
  right: "auto",
  bottom: "auto",
  left: "auto"
};
function sr(e, t) {
  var n = e.x, i = e.y, r = t.devicePixelRatio || 1;
  return {
    x: pt(n * r) / r || 0,
    y: pt(i * r) / r || 0
  };
}
function We(e) {
  var t, n = e.popper, i = e.popperRect, r = e.placement, s = e.variation, a = e.offsets, c = e.position, o = e.gpuAcceleration, l = e.adaptive, d = e.roundOffsets, b = e.isFixed, v = a.x, h = v === void 0 ? 0 : v, $ = a.y, u = $ === void 0 ? 0 : $, w = typeof d == "function" ? d({
    x: h,
    y: u
  }) : {
    x: h,
    y: u
  };
  h = w.x, u = w.y;
  var E = a.hasOwnProperty("x"), O = a.hasOwnProperty("y"), L = D, f = P, y = window;
  if (l) {
    var x = Dt(n), k = "clientHeight", T = "clientWidth";
    if (x === F(n) && (x = Z(n), G(x).position !== "static" && c === "absolute" && (k = "scrollHeight", T = "scrollWidth")), x = x, r === P || (r === D || r === _) && s === It) {
      f = W;
      var S = b && x === y && y.visualViewport ? y.visualViewport.height : (
        // $FlowFixMe[prop-missing]
        x[k]
      );
      u -= S - i.height, u *= o ? 1 : -1;
    }
    if (r === D || (r === P || r === W) && s === It) {
      L = _;
      var C = b && x === y && y.visualViewport ? y.visualViewport.width : (
        // $FlowFixMe[prop-missing]
        x[T]
      );
      h -= C - i.width, h *= o ? 1 : -1;
    }
  }
  var I = Object.assign({
    position: c
  }, l && rr), B = d === !0 ? sr({
    x: h,
    y: u
  }, F(n)) : {
    x: h,
    y: u
  };
  if (h = B.x, u = B.y, o) {
    var A;
    return Object.assign({}, I, (A = {}, A[f] = O ? "0" : "", A[L] = E ? "0" : "", A.transform = (y.devicePixelRatio || 1) <= 1 ? "translate(" + h + "px, " + u + "px)" : "translate3d(" + h + "px, " + u + "px, 0)", A));
  }
  return Object.assign({}, I, (t = {}, t[f] = O ? u + "px" : "", t[L] = E ? h + "px" : "", t.transform = "", t));
}
function or(e) {
  var t = e.state, n = e.options, i = n.gpuAcceleration, r = i === void 0 ? !0 : i, s = n.adaptive, a = s === void 0 ? !0 : s, c = n.roundOffsets, o = c === void 0 ? !0 : c, l = {
    placement: J(t.placement),
    variation: mt(t.placement),
    popper: t.elements.popper,
    popperRect: t.rects.popper,
    gpuAcceleration: r,
    isFixed: t.options.strategy === "fixed"
  };
  t.modifiersData.popperOffsets != null && (t.styles.popper = Object.assign({}, t.styles.popper, We(Object.assign({}, l, {
    offsets: t.modifiersData.popperOffsets,
    position: t.options.strategy,
    adaptive: a,
    roundOffsets: o
  })))), t.modifiersData.arrow != null && (t.styles.arrow = Object.assign({}, t.styles.arrow, We(Object.assign({}, l, {
    offsets: t.modifiersData.arrow,
    position: "absolute",
    adaptive: !1,
    roundOffsets: o
  })))), t.attributes.popper = Object.assign({}, t.attributes.popper, {
    "data-popper-placement": t.placement
  });
}
const ar = {
  name: "computeStyles",
  enabled: !0,
  phase: "beforeWrite",
  fn: or,
  data: {}
};
var Bt = {
  passive: !0
};
function lr(e) {
  var t = e.state, n = e.instance, i = e.options, r = i.scroll, s = r === void 0 ? !0 : r, a = i.resize, c = a === void 0 ? !0 : a, o = F(t.elements.popper), l = [].concat(t.scrollParents.reference, t.scrollParents.popper);
  return s && l.forEach(function(d) {
    d.addEventListener("scroll", n.update, Bt);
  }), c && o.addEventListener("resize", n.update, Bt), function() {
    s && l.forEach(function(d) {
      d.removeEventListener("scroll", n.update, Bt);
    }), c && o.removeEventListener("resize", n.update, Bt);
  };
}
const cr = {
  name: "eventListeners",
  enabled: !0,
  phase: "write",
  fn: function() {
  },
  effect: lr,
  data: {}
};
var dr = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
};
function Ht(e) {
  return e.replace(/left|right|bottom|top/g, function(t) {
    return dr[t];
  });
}
var ur = {
  start: "end",
  end: "start"
};
function _e(e) {
  return e.replace(/start|end/g, function(t) {
    return ur[t];
  });
}
function be(e) {
  var t = F(e), n = t.pageXOffset, i = t.pageYOffset;
  return {
    scrollLeft: n,
    scrollTop: i
  };
}
function ye(e) {
  return gt(Z(e)).left + be(e).scrollLeft;
}
function hr(e, t) {
  var n = F(e), i = Z(e), r = n.visualViewport, s = i.clientWidth, a = i.clientHeight, c = 0, o = 0;
  if (r) {
    s = r.width, a = r.height;
    var l = pn();
    (l || !l && t === "fixed") && (c = r.offsetLeft, o = r.offsetTop);
  }
  return {
    width: s,
    height: a,
    x: c + ye(e),
    y: o
  };
}
function fr(e) {
  var t, n = Z(e), i = be(e), r = (t = e.ownerDocument) == null ? void 0 : t.body, s = rt(n.scrollWidth, n.clientWidth, r ? r.scrollWidth : 0, r ? r.clientWidth : 0), a = rt(n.scrollHeight, n.clientHeight, r ? r.scrollHeight : 0, r ? r.clientHeight : 0), c = -i.scrollLeft + ye(e), o = -i.scrollTop;
  return G(r || n).direction === "rtl" && (c += rt(n.clientWidth, r ? r.clientWidth : 0) - s), {
    width: s,
    height: a,
    x: c,
    y: o
  };
}
function we(e) {
  var t = G(e), n = t.overflow, i = t.overflowX, r = t.overflowY;
  return /auto|scroll|overlay|hidden/.test(n + r + i);
}
function yn(e) {
  return ["html", "body", "#document"].indexOf(z(e)) >= 0 ? e.ownerDocument.body : N(e) && we(e) ? e : yn(Gt(e));
}
function Ct(e, t) {
  var n;
  t === void 0 && (t = []);
  var i = yn(e), r = i === ((n = e.ownerDocument) == null ? void 0 : n.body), s = F(i), a = r ? [s].concat(s.visualViewport || [], we(i) ? i : []) : i, c = t.concat(a);
  return r ? c : (
    // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
    c.concat(Ct(Gt(a)))
  );
}
function se(e) {
  return Object.assign({}, e, {
    left: e.x,
    top: e.y,
    right: e.x + e.width,
    bottom: e.y + e.height
  });
}
function pr(e, t) {
  var n = gt(e, !1, t === "fixed");
  return n.top = n.top + e.clientTop, n.left = n.left + e.clientLeft, n.bottom = n.top + e.clientHeight, n.right = n.left + e.clientWidth, n.width = e.clientWidth, n.height = e.clientHeight, n.x = n.left, n.y = n.top, n;
}
function Be(e, t, n) {
  return t === hn ? se(hr(e, n)) : st(t) ? pr(t, n) : se(fr(Z(e)));
}
function gr(e) {
  var t = Ct(Gt(e)), n = ["absolute", "fixed"].indexOf(G(e).position) >= 0, i = n && N(e) ? Dt(e) : e;
  return st(i) ? t.filter(function(r) {
    return st(r) && gn(r, i) && z(r) !== "body";
  }) : [];
}
function mr(e, t, n, i) {
  var r = t === "clippingParents" ? gr(e) : [].concat(t), s = [].concat(r, [n]), a = s[0], c = s.reduce(function(o, l) {
    var d = Be(e, l, i);
    return o.top = rt(d.top, o.top), o.right = Jt(d.right, o.right), o.bottom = Jt(d.bottom, o.bottom), o.left = rt(d.left, o.left), o;
  }, Be(e, a, i));
  return c.width = c.right - c.left, c.height = c.bottom - c.top, c.x = c.left, c.y = c.top, c;
}
function wn(e) {
  var t = e.reference, n = e.element, i = e.placement, r = i ? J(i) : null, s = i ? mt(i) : null, a = t.x + t.width / 2 - n.width / 2, c = t.y + t.height / 2 - n.height / 2, o;
  switch (r) {
    case P:
      o = {
        x: a,
        y: t.y - n.height
      };
      break;
    case W:
      o = {
        x: a,
        y: t.y + t.height
      };
      break;
    case _:
      o = {
        x: t.x + t.width,
        y: c
      };
      break;
    case D:
      o = {
        x: t.x - n.width,
        y: c
      };
      break;
    default:
      o = {
        x: t.x,
        y: t.y
      };
  }
  var l = r ? ve(r) : null;
  if (l != null) {
    var d = l === "y" ? "height" : "width";
    switch (s) {
      case ft:
        o[l] = o[l] - (t[d] / 2 - n[d] / 2);
        break;
      case It:
        o[l] = o[l] + (t[d] / 2 - n[d] / 2);
        break;
    }
  }
  return o;
}
function At(e, t) {
  t === void 0 && (t = {});
  var n = t, i = n.placement, r = i === void 0 ? e.placement : i, s = n.strategy, a = s === void 0 ? e.strategy : s, c = n.boundary, o = c === void 0 ? qi : c, l = n.rootBoundary, d = l === void 0 ? hn : l, b = n.elementContext, v = b === void 0 ? yt : b, h = n.altBoundary, $ = h === void 0 ? !1 : h, u = n.padding, w = u === void 0 ? 0 : u, E = vn(typeof w != "number" ? w : bn(w, Pt)), O = v === yt ? Fi : yt, L = e.rects.popper, f = e.elements[$ ? O : v], y = mr(st(f) ? f : f.contextElement || Z(e.elements.popper), o, d, a), x = gt(e.elements.reference), k = wn({
    reference: x,
    element: L,
    strategy: "absolute",
    placement: r
  }), T = se(Object.assign({}, L, k)), S = v === yt ? T : x, C = {
    top: y.top - S.top + E.top,
    bottom: S.bottom - y.bottom + E.bottom,
    left: y.left - S.left + E.left,
    right: S.right - y.right + E.right
  }, I = e.modifiersData.offset;
  if (v === yt && I) {
    var B = I[r];
    Object.keys(C).forEach(function(A) {
      var X = [_, W].indexOf(A) >= 0 ? 1 : -1, Y = [P, W].indexOf(A) >= 0 ? "y" : "x";
      C[A] += B[Y] * X;
    });
  }
  return C;
}
function vr(e, t) {
  t === void 0 && (t = {});
  var n = t, i = n.placement, r = n.boundary, s = n.rootBoundary, a = n.padding, c = n.flipVariations, o = n.allowedAutoPlacements, l = o === void 0 ? fn : o, d = mt(i), b = d ? c ? Fe : Fe.filter(function($) {
    return mt($) === d;
  }) : Pt, v = b.filter(function($) {
    return l.indexOf($) >= 0;
  });
  v.length === 0 && (v = b);
  var h = v.reduce(function($, u) {
    return $[u] = At(e, {
      placement: u,
      boundary: r,
      rootBoundary: s,
      padding: a
    })[J(u)], $;
  }, {});
  return Object.keys(h).sort(function($, u) {
    return h[$] - h[u];
  });
}
function br(e) {
  if (J(e) === pe)
    return [];
  var t = Ht(e);
  return [_e(e), t, _e(t)];
}
function yr(e) {
  var t = e.state, n = e.options, i = e.name;
  if (!t.modifiersData[i]._skip) {
    for (var r = n.mainAxis, s = r === void 0 ? !0 : r, a = n.altAxis, c = a === void 0 ? !0 : a, o = n.fallbackPlacements, l = n.padding, d = n.boundary, b = n.rootBoundary, v = n.altBoundary, h = n.flipVariations, $ = h === void 0 ? !0 : h, u = n.allowedAutoPlacements, w = t.options.placement, E = J(w), O = E === w, L = o || (O || !$ ? [Ht(w)] : br(w)), f = [w].concat(L).reduce(function(tt, K) {
      return tt.concat(J(K) === pe ? vr(t, {
        placement: K,
        boundary: d,
        rootBoundary: b,
        padding: l,
        flipVariations: $,
        allowedAutoPlacements: u
      }) : K);
    }, []), y = t.rects.reference, x = t.rects.popper, k = /* @__PURE__ */ new Map(), T = !0, S = f[0], C = 0; C < f.length; C++) {
      var I = f[C], B = J(I), A = mt(I) === ft, X = [P, W].indexOf(B) >= 0, Y = X ? "width" : "height", M = At(t, {
        placement: I,
        boundary: d,
        rootBoundary: b,
        altBoundary: v,
        padding: l
      }), R = X ? A ? _ : D : A ? W : P;
      y[Y] > x[Y] && (R = Ht(R));
      var Mt = Ht(R), U = [];
      if (s && U.push(M[B] <= 0), c && U.push(M[R] <= 0, M[Mt] <= 0), U.every(function(tt) {
        return tt;
      })) {
        S = I, T = !1;
        break;
      }
      k.set(I, U);
    }
    if (T)
      for (var jt = $ ? 3 : 1, Qt = function(tt) {
        var K = f.find(function(Ft) {
          var bt = k.get(Ft);
          if (bt)
            return bt.slice(0, tt).every(function(ot) {
              return ot;
            });
        });
        if (K)
          return S = K, "break";
      }, vt = jt; vt > 0; vt--) {
        var qt = Qt(vt);
        if (qt === "break")
          break;
      }
    t.placement !== S && (t.modifiersData[i]._skip = !0, t.placement = S, t.reset = !0);
  }
}
const wr = {
  name: "flip",
  enabled: !0,
  phase: "main",
  fn: yr,
  requiresIfExists: ["offset"],
  data: {
    _skip: !1
  }
};
function Re(e, t, n) {
  return n === void 0 && (n = {
    x: 0,
    y: 0
  }), {
    top: e.top - t.height - n.y,
    right: e.right - t.width + n.x,
    bottom: e.bottom - t.height + n.y,
    left: e.left - t.width - n.x
  };
}
function Ve(e) {
  return [P, _, W, D].some(function(t) {
    return e[t] >= 0;
  });
}
function $r(e) {
  var t = e.state, n = e.name, i = t.rects.reference, r = t.rects.popper, s = t.modifiersData.preventOverflow, a = At(t, {
    elementContext: "reference"
  }), c = At(t, {
    altBoundary: !0
  }), o = Re(a, i), l = Re(c, r, s), d = Ve(o), b = Ve(l);
  t.modifiersData[n] = {
    referenceClippingOffsets: o,
    popperEscapeOffsets: l,
    isReferenceHidden: d,
    hasPopperEscaped: b
  }, t.attributes.popper = Object.assign({}, t.attributes.popper, {
    "data-popper-reference-hidden": d,
    "data-popper-escaped": b
  });
}
const Er = {
  name: "hide",
  enabled: !0,
  phase: "main",
  requiresIfExists: ["preventOverflow"],
  fn: $r
};
function xr(e, t, n) {
  var i = J(e), r = [D, P].indexOf(i) >= 0 ? -1 : 1, s = typeof n == "function" ? n(Object.assign({}, t, {
    placement: e
  })) : n, a = s[0], c = s[1];
  return a = a || 0, c = (c || 0) * r, [D, _].indexOf(i) >= 0 ? {
    x: c,
    y: a
  } : {
    x: a,
    y: c
  };
}
function Or(e) {
  var t = e.state, n = e.options, i = e.name, r = n.offset, s = r === void 0 ? [0, 0] : r, a = fn.reduce(function(d, b) {
    return d[b] = xr(b, t.rects, s), d;
  }, {}), c = a[t.placement], o = c.x, l = c.y;
  t.modifiersData.popperOffsets != null && (t.modifiersData.popperOffsets.x += o, t.modifiersData.popperOffsets.y += l), t.modifiersData[i] = a;
}
const Lr = {
  name: "offset",
  enabled: !0,
  phase: "main",
  requires: ["popperOffsets"],
  fn: Or
};
function kr(e) {
  var t = e.state, n = e.name;
  t.modifiersData[n] = wn({
    reference: t.rects.reference,
    element: t.rects.popper,
    strategy: "absolute",
    placement: t.placement
  });
}
const Tr = {
  name: "popperOffsets",
  enabled: !0,
  phase: "read",
  fn: kr,
  data: {}
};
function Sr(e) {
  return e === "x" ? "y" : "x";
}
function Cr(e) {
  var t = e.state, n = e.options, i = e.name, r = n.mainAxis, s = r === void 0 ? !0 : r, a = n.altAxis, c = a === void 0 ? !1 : a, o = n.boundary, l = n.rootBoundary, d = n.altBoundary, b = n.padding, v = n.tether, h = v === void 0 ? !0 : v, $ = n.tetherOffset, u = $ === void 0 ? 0 : $, w = At(t, {
    boundary: o,
    rootBoundary: l,
    padding: b,
    altBoundary: d
  }), E = J(t.placement), O = mt(t.placement), L = !O, f = ve(E), y = Sr(f), x = t.modifiersData.popperOffsets, k = t.rects.reference, T = t.rects.popper, S = typeof u == "function" ? u(Object.assign({}, t.rects, {
    placement: t.placement
  })) : u, C = typeof S == "number" ? {
    mainAxis: S,
    altAxis: S
  } : Object.assign({
    mainAxis: 0,
    altAxis: 0
  }, S), I = t.modifiersData.offset ? t.modifiersData.offset[t.placement] : null, B = {
    x: 0,
    y: 0
  };
  if (x) {
    if (s) {
      var A, X = f === "y" ? P : D, Y = f === "y" ? W : _, M = f === "y" ? "height" : "width", R = x[f], Mt = R + w[X], U = R - w[Y], jt = h ? -T[M] / 2 : 0, Qt = O === ft ? k[M] : T[M], vt = O === ft ? -T[M] : -k[M], qt = t.elements.arrow, tt = h && qt ? me(qt) : {
        width: 0,
        height: 0
      }, K = t.modifiersData["arrow#persistent"] ? t.modifiersData["arrow#persistent"].padding : mn(), Ft = K[X], bt = K[Y], ot = St(0, k[M], tt[M]), xn = L ? k[M] / 2 - jt - ot - Ft - C.mainAxis : Qt - ot - Ft - C.mainAxis, On = L ? -k[M] / 2 + jt + ot + bt + C.mainAxis : vt + ot + bt + C.mainAxis, Zt = t.elements.arrow && Dt(t.elements.arrow), Ln = Zt ? f === "y" ? Zt.clientTop || 0 : Zt.clientLeft || 0 : 0, Ee = (A = I == null ? void 0 : I[f]) != null ? A : 0, kn = R + xn - Ee - Ln, Tn = R + On - Ee, xe = St(h ? Jt(Mt, kn) : Mt, R, h ? rt(U, Tn) : U);
      x[f] = xe, B[f] = xe - R;
    }
    if (c) {
      var Oe, Sn = f === "x" ? P : D, Cn = f === "x" ? W : _, et = x[y], Nt = y === "y" ? "height" : "width", Le = et + w[Sn], ke = et - w[Cn], Xt = [P, D].indexOf(E) !== -1, Te = (Oe = I == null ? void 0 : I[y]) != null ? Oe : 0, Se = Xt ? Le : et - k[Nt] - T[Nt] - Te + C.altAxis, Ce = Xt ? et + k[Nt] + T[Nt] - Te - C.altAxis : ke, Ie = h && Xt ? Ui(Se, et, Ce) : St(h ? Se : Le, et, h ? Ce : ke);
      x[y] = Ie, B[y] = Ie - et;
    }
    t.modifiersData[i] = B;
  }
}
const Ir = {
  name: "preventOverflow",
  enabled: !0,
  phase: "main",
  fn: Cr,
  requiresIfExists: ["offset"]
};
function Ar(e) {
  return {
    scrollLeft: e.scrollLeft,
    scrollTop: e.scrollTop
  };
}
function Pr(e) {
  return e === F(e) || !N(e) ? be(e) : Ar(e);
}
function Dr(e) {
  var t = e.getBoundingClientRect(), n = pt(t.width) / e.offsetWidth || 1, i = pt(t.height) / e.offsetHeight || 1;
  return n !== 1 || i !== 1;
}
function Mr(e, t, n) {
  n === void 0 && (n = !1);
  var i = N(t), r = N(t) && Dr(t), s = Z(t), a = gt(e, r, n), c = {
    scrollLeft: 0,
    scrollTop: 0
  }, o = {
    x: 0,
    y: 0
  };
  return (i || !i && !n) && ((z(t) !== "body" || // https://github.com/popperjs/popper-core/issues/1078
  we(s)) && (c = Pr(t)), N(t) ? (o = gt(t, !0), o.x += t.clientLeft, o.y += t.clientTop) : s && (o.x = ye(s))), {
    x: a.left + c.scrollLeft - o.x,
    y: a.top + c.scrollTop - o.y,
    width: a.width,
    height: a.height
  };
}
function jr(e) {
  var t = /* @__PURE__ */ new Map(), n = /* @__PURE__ */ new Set(), i = [];
  e.forEach(function(s) {
    t.set(s.name, s);
  });
  function r(s) {
    n.add(s.name);
    var a = [].concat(s.requires || [], s.requiresIfExists || []);
    a.forEach(function(c) {
      if (!n.has(c)) {
        var o = t.get(c);
        o && r(o);
      }
    }), i.push(s);
  }
  return e.forEach(function(s) {
    n.has(s.name) || r(s);
  }), i;
}
function qr(e) {
  var t = jr(e);
  return Ki.reduce(function(n, i) {
    return n.concat(t.filter(function(r) {
      return r.phase === i;
    }));
  }, []);
}
function Fr(e) {
  var t;
  return function() {
    return t || (t = new Promise(function(n) {
      Promise.resolve().then(function() {
        t = void 0, n(e());
      });
    })), t;
  };
}
function Nr(e) {
  var t = e.reduce(function(n, i) {
    var r = n[i.name];
    return n[i.name] = r ? Object.assign({}, r, i, {
      options: Object.assign({}, r.options, i.options),
      data: Object.assign({}, r.data, i.data)
    }) : i, n;
  }, {});
  return Object.keys(t).map(function(n) {
    return t[n];
  });
}
var He = {
  placement: "bottom",
  modifiers: [],
  strategy: "absolute"
};
function Je() {
  for (var e = arguments.length, t = new Array(e), n = 0; n < e; n++)
    t[n] = arguments[n];
  return !t.some(function(i) {
    return !(i && typeof i.getBoundingClientRect == "function");
  });
}
function Wr(e) {
  e === void 0 && (e = {});
  var t = e, n = t.defaultModifiers, i = n === void 0 ? [] : n, r = t.defaultOptions, s = r === void 0 ? He : r;
  return function(a, c, o) {
    o === void 0 && (o = s);
    var l = {
      placement: "bottom",
      orderedModifiers: [],
      options: Object.assign({}, He, s),
      modifiersData: {},
      elements: {
        reference: a,
        popper: c
      },
      attributes: {},
      styles: {}
    }, d = [], b = !1, v = {
      state: l,
      setOptions: function(u) {
        var w = typeof u == "function" ? u(l.options) : u;
        $(), l.options = Object.assign({}, s, l.options, w), l.scrollParents = {
          reference: st(a) ? Ct(a) : a.contextElement ? Ct(a.contextElement) : [],
          popper: Ct(c)
        };
        var E = qr(Nr([].concat(i, l.options.modifiers)));
        return l.orderedModifiers = E.filter(function(O) {
          return O.enabled;
        }), h(), v.update();
      },
      // Sync update – it will always be executed, even if not necessary. This
      // is useful for low frequency updates where sync behavior simplifies the
      // logic.
      // For high frequency updates (e.g. `resize` and `scroll` events), always
      // prefer the async Popper#update method
      forceUpdate: function() {
        if (!b) {
          var u = l.elements, w = u.reference, E = u.popper;
          if (Je(w, E)) {
            l.rects = {
              reference: Mr(w, Dt(E), l.options.strategy === "fixed"),
              popper: me(E)
            }, l.reset = !1, l.placement = l.options.placement, l.orderedModifiers.forEach(function(T) {
              return l.modifiersData[T.name] = Object.assign({}, T.data);
            });
            for (var O = 0; O < l.orderedModifiers.length; O++) {
              if (l.reset === !0) {
                l.reset = !1, O = -1;
                continue;
              }
              var L = l.orderedModifiers[O], f = L.fn, y = L.options, x = y === void 0 ? {} : y, k = L.name;
              typeof f == "function" && (l = f({
                state: l,
                options: x,
                name: k,
                instance: v
              }) || l);
            }
          }
        }
      },
      // Async and optimistically optimized update – it will not be executed if
      // not necessary (debounced to run at most once-per-tick)
      update: Fr(function() {
        return new Promise(function(u) {
          v.forceUpdate(), u(l);
        });
      }),
      destroy: function() {
        $(), b = !0;
      }
    };
    if (!Je(a, c))
      return v;
    v.setOptions(o).then(function(u) {
      !b && o.onFirstUpdate && o.onFirstUpdate(u);
    });
    function h() {
      l.orderedModifiers.forEach(function(u) {
        var w = u.name, E = u.options, O = E === void 0 ? {} : E, L = u.effect;
        if (typeof L == "function") {
          var f = L({
            state: l,
            name: w,
            instance: v,
            options: O
          }), y = function() {
          };
          d.push(f || y);
        }
      });
    }
    function $() {
      d.forEach(function(u) {
        return u();
      }), d = [];
    }
    return v;
  };
}
var _r = [cr, Tr, ar, Zi, Lr, wr, Ir, ir, Er], Br = /* @__PURE__ */ Wr({
  defaultModifiers: _r
});
async function oe(e) {
  const t = this.collection.findIndex((n) => n.id === e.id);
  if (t >= 0) {
    const n = this.collection[t];
    n.state === "opened" && n.close(), n.popper.destroy(), $n(n), Object.getOwnPropertyNames(n).forEach((i) => {
      delete n[i];
    }), this.collection.splice(t, 1);
  }
  return this.collection;
}
function $n(e) {
  return e.__eventListeners && (e.__eventListeners.forEach((t) => {
    t.el.forEach((n) => {
      t.type.forEach((i) => {
        e[n].removeEventListener(i, t.listener, !1);
      });
    });
  }), delete e.__eventListeners), e;
}
async function $e(e) {
  const t = ln.call(this, e);
  return t.el.classList.add(this.settings.stateActive), t.trigger.hasAttribute("aria-controls") && t.trigger.setAttribute("aria-expanded", "true"), t.config = an(t.el, this.settings), t.popper.setOptions({
    placement: t.config.placement,
    modifiers: [
      { name: "eventListeners", enabled: !0 },
      ...Ai(t.config)
    ]
  }), t.popper.update(), t.state = "opened", t;
}
async function Rr(e, t) {
  oe.call(this, e);
  const n = this, i = {
    id: e.id,
    state: "closed",
    el: e,
    trigger: t,
    popper: Br(t, e),
    config: an(e, this.settings),
    open() {
      return $e.call(n, this);
    },
    close() {
      return fe.call(n, this);
    },
    deregister() {
      return oe.call(n, this);
    }
  };
  return i.trigger.hasAttribute("aria-controls") && i.trigger.setAttribute("aria-expanded", "false"), En.call(this, i), this.collection.push(i), i.el.classList.contains(this.settings.stateActive) && (await i.open(), un.call(this, i)), i;
}
function En(e) {
  return e.__eventListeners || (e.config.event === "hover" ? (e.__eventListeners = [{
    el: ["trigger"],
    type: ["mouseenter", "focus"],
    listener: $e.bind(this, e)
  }, {
    el: ["el", "trigger"],
    type: ["mouseleave", "focusout"],
    listener: dn.bind(this, e)
  }], e.__eventListeners.forEach((t) => {
    t.el.forEach((n) => {
      t.type.forEach((i) => {
        e[n].addEventListener(i, t.listener, !1);
      });
    });
  })) : (e.__eventListeners = [{
    el: ["trigger"],
    type: ["click"],
    listener: Mi.bind(this, e)
  }], e.__eventListeners.forEach((t) => {
    t.el.forEach((n) => {
      t.type.forEach((i) => {
        e[n].addEventListener(i, t.listener, !1);
      });
    });
  }))), e;
}
var Tt;
class ts extends Si {
  constructor(t) {
    super(), ki(this, Tt, void 0), this.defaults = Ii, this.settings = { ...this.defaults, ...t }, this.trigger = null, Ti(this, Tt, ji.bind(this)), this.settings.autoInit && this.init();
  }
  async init(t) {
    t && (this.settings = { ...this.settings, ...t });
    const n = document.querySelectorAll(this.settings.selectorPopover);
    return await this.registerCollection(n), this.settings.eventListeners && this.initEventListeners(!1), this;
  }
  async destroy() {
    return this.trigger = null, await this.deregisterCollection(), this.settings.eventListeners && this.destroyEventListeners(!1), this;
  }
  initEventListeners(t = !0) {
    t && this.collection.forEach((n) => {
      En.call(this, n);
    }), document.addEventListener("keydown", qe(this, Tt), !1);
  }
  destroyEventListeners(t = !0) {
    t && this.collection.forEach((n) => {
      $n(n);
    }), document.removeEventListener("keydown", qe(this, Tt), !1);
  }
  register(t) {
    const n = Di.call(this, t);
    return n.error ? Promise.reject(n.error) : Rr.call(this, n.popover, n.trigger);
  }
  deregister(t) {
    let n = this.get(t.id || t);
    return n ? oe.call(this, n) : Promise.reject(new Error(`Failed to deregister; popover does not exist in collection with ID of: "${t.id || t}".`));
  }
  open(t) {
    return $e.call(this, t);
  }
  close(t) {
    return fe.call(this, t);
  }
}
Tt = /* @__PURE__ */ new WeakMap();
export {
  Zr as Drawer,
  Yr as Modal,
  ts as Popover,
  zr as core
};
//# sourceMappingURL=index.js.map
